import "antd/es/spin/style";
import _Spin from "antd/es/spin";
import "antd/es/config-provider/style";
import _ConfigProvider from "antd/es/config-provider";
import "antd/es/pagination/style";
import _Pagination from "antd/es/pagination";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState } from 'react';
import classNames from 'classnames';
import omit from 'rc-util/lib/omit';
import produce from 'immer';
import zhCN from 'antd/es/locale/zh_CN';
import _ from 'lodash';
import { Provider, useSelector } from 'react-redux';
import { useClickAway } from 'ahooks';
import { ExperimentTable } from '../ExperimentTable';
import usePagination, { DEFAULT_PAGE_SIZE, getPaginationParam } from './hooks/usePagination';
import useSelection from './hooks/useSelection';
import useLazyKVMap from './hooks/useLazyKVMap';
import useTitleColumns from './hooks/useTitleColumns';
import useFilter from './hooks/useFilter/index';
import useTable from './hooks/useTable';
import Toolbar from './Toolbar';
import '../assets/icomoon/style.css';
import "./style/index.css";
import { ArtTableContext } from './core/ArtTableContext';
import { ArtTableHelpContext } from './core/ArtTableHelpContext';
import { ArtTableEditableCellContext } from './core/ArtTableEditableCellContext';
import { formatTableStoreInInImmutable, computedColumn } from './utils';
var EMPTY_LIST = [];
export var ArtTableAction;

(function (ArtTableAction) {
  ArtTableAction["pagination"] = "pagination";
  ArtTableAction["filter"] = "filter";
  ArtTableAction["sort"] = "sort";
  ArtTableAction["fieldConfig"] = "fieldConfig";
  ArtTableAction["lineHeight"] = "lineHeight";
  ArtTableAction["globalShow"] = "globalShow";
  ArtTableAction["column"] = "column";
  ArtTableAction["tableScroll"] = "tableScroll";
})(ArtTableAction || (ArtTableAction = {}));

export var sizeMap = new Map([['large', 120], ['middle', 64], ['small', 32]]);

function ArtTable(props) {
  var _classNames2;

  var dataSource = props.dataSource,
      columns = props.columns,
      loading = props.loading,
      pagination = props.pagination,
      scroll = props.scroll,
      onChange = props.onChange,
      rowSelection = props.rowSelection,
      rowKey = props.rowKey,
      toolbarSlots = props.toolbarSlots,
      emptyText = props.emptyText,
      manager = props.manager,
      cellExtraRender = props.cellExtraRender,
      _props$checkedColumnL = props.checkedColumnLengthLowerLimit,
      checkedColumnLengthLowerLimit = _props$checkedColumnL === void 0 ? 6 : _props$checkedColumnL,
      _props$fixedColumnLen = props.fixedColumnLengthUpperLimit,
      fixedColumnLengthUpperLimit = _props$fixedColumnLen === void 0 ? 4 : _props$fixedColumnLen,
      _props$sortRulesLengt = props.sortRulesLengthUpperLimit,
      sortRulesLengthUpperLimit = _props$sortRulesLengt === void 0 ? 10 : _props$sortRulesLengt;

  var _useSelector = useSelector(function (state) {
    return {
      columnConfig: state.columnConfig.byId,
      size: state.size,
      isGlobalShow: state.isGlobalShow
    };
  }),
      columnConfig = _useSelector.columnConfig,
      size = _useSelector.size,
      isGlobalShow = _useSelector.isGlobalShow;

  var childrenColumnName = 'children';
  var tableProps = omit(props, ['className', 'style', 'columns']);
  var prefixCls = 'kodo-art-table';
  var rawData = dataSource || EMPTY_LIST;
  var mergedData = rawData.slice();
  var internalRefs = {
    body: React.useRef(),
    container: React.useRef(),
    bodyInner: React.useRef()
  }; // ============================ RowKey ============================

  var getRowKey = React.useMemo(function () {
    if (typeof rowKey === 'function') {
      return rowKey;
    }

    return function (record) {
      return record === null || record === void 0 ? void 0 : record[rowKey];
    };
  }, [rowKey]);

  var _useLazyKVMap = useLazyKVMap(rawData, childrenColumnName, getRowKey),
      _useLazyKVMap2 = _slicedToArray(_useLazyKVMap, 1),
      getRecordByKey = _useLazyKVMap2[0]; // ============================ Events =============================


  var changeEventInfo = {};

  var triggerOnChange = function triggerOnChange(info, action) {
    var reset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    var changeInfo = _objectSpread(_objectSpread({}, changeEventInfo), info);

    if (reset) {
      changeEventInfo.resetPagination(); // Reset event param

      if (changeInfo.pagination.current) {
        changeInfo.pagination.current = 1;
      } // Trigger pagination events


      if (pagination && pagination.onChange) {
        pagination.onChange(1, changeInfo.pagination.pageSize);
      }
    }

    if (scroll && scroll.scrollToFirstRowOnChange !== false && internalRefs.body.current) {
      var _internalRefs$body$cu;

      (_internalRefs$body$cu = internalRefs.body.current) === null || _internalRefs$body$cu === void 0 ? void 0 : _internalRefs$body$cu.setPosition({
        top: 0
      });
    }

    onChange === null || onChange === void 0 ? void 0 : onChange(info, manager.getState(), action);
  }; // >>>>>>>>> filter


  var onFilterChange = function onFilterChange(filter) {
    triggerOnChange({
      filter: filter
    }, 'filter');
  };

  var _useFilter = useFilter({
    prefixCls: prefixCls,
    mergedColumns: columns,
    onFilterChange: onFilterChange
  }),
      _useFilter2 = _slicedToArray(_useFilter, 1),
      transformFilterColumns = _useFilter2[0]; // >>>>>>>>> column


  var onColumnChange = function onColumnChange(column) {
    triggerOnChange({
      column: column
    }, 'column');
  };

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isTableColumnResize = _useState2[0],
      setIsTableColumnResize = _useState2[1];

  var _useTitleColumns = useTitleColumns(manager, {
    onColumnChange: onColumnChange
  }),
      _useTitleColumns2 = _slicedToArray(_useTitleColumns, 1),
      transformTitleColumns = _useTitleColumns2[0]; // >>>>>>>>> pagination


  var onPaginationChange = function onPaginationChange(current, pageSize) {
    // manager.getActions().updatePagination({ pageSize });
    triggerOnChange({
      pagination: _objectSpread(_objectSpread({}, changeEventInfo.pagination), {}, {
        current: current,
        pageSize: pageSize
      })
    }, 'pagination');
  };

  var _usePagination = usePagination(rawData.length, pagination, onPaginationChange),
      _usePagination2 = _slicedToArray(_usePagination, 2),
      mergedPagination = _usePagination2[0],
      resetPagination = _usePagination2[1];

  changeEventInfo.pagination = pagination === false ? {} : getPaginationParam(pagination, mergedPagination);
  changeEventInfo.resetPagination = resetPagination;
  var bottomPaginationNode;

  if (pagination !== false && (mergedPagination === null || mergedPagination === void 0 ? void 0 : mergedPagination.total)) {
    var renderPagination = function renderPagination(position) {
      return /*#__PURE__*/React.createElement(_Pagination, _objectSpread(_objectSpread({
        className: "".concat(prefixCls, "-pagination ").concat(prefixCls, "-pagination-").concat(position),
        showSizeChanger: true,
        showQuickJumper: true
      }, mergedPagination), {}, {
        size: 'default'
      }));
    };

    bottomPaginationNode = renderPagination('right');
  } // >>>>>>>>> Spinning


  var spinProps;

  if (typeof loading === 'boolean') {
    spinProps = {
      spinning: loading
    };
  } else if (_typeof(loading) === 'object') {
    spinProps = _objectSpread({
      spinning: true
    }, loading);
  } // ============================= Data =============================


  var pageData = React.useMemo(function () {
    if (isGlobalShow || pagination === false || !mergedPagination.pageSize) {
      return mergedData;
    }

    var _mergedPagination$cur = mergedPagination.current,
        current = _mergedPagination$cur === void 0 ? 1 : _mergedPagination$cur,
        total = mergedPagination.total,
        _mergedPagination$pag = mergedPagination.pageSize,
        pageSize = _mergedPagination$pag === void 0 ? DEFAULT_PAGE_SIZE : _mergedPagination$pag; // Dynamic table data

    if (mergedData.length < total) {
      if (mergedData.length > pageSize) {
        return mergedData.slice((current - 1) * pageSize, current * pageSize);
      }

      return mergedData;
    }

    return mergedData.slice((current - 1) * pageSize, current * pageSize);
  }, [!!pagination, mergedData, isGlobalShow, mergedPagination && mergedPagination.current, mergedPagination && mergedPagination.pageSize, mergedPagination && mergedPagination.total]); // ========================== Selections ==========================

  var _useSelection = useSelection(rowSelection, {
    prefixCls: prefixCls,
    data: mergedData,
    pageData: pageData,
    getRowKey: getRowKey,
    getRecordByKey: getRecordByKey,
    childrenColumnName: childrenColumnName
  }),
      _useSelection2 = _slicedToArray(_useSelection, 2),
      transformSelectionColumns = _useSelection2[0],
      selectedKeySet = _useSelection2[1]; // ============================ Render ============================


  var transformColumns = React.useCallback(function (innerColumns) {
    return transformTitleColumns(transformSelectionColumns(transformFilterColumns(innerColumns)));
  }, [transformFilterColumns, transformSelectionColumns]);

  var internalRowClassName = function internalRowClassName(record, index) {
    return classNames(_defineProperty({}, "".concat(prefixCls, "-row-selected"), selectedKeySet.has(getRowKey(record, index))));
  };

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      init = _useState4[0],
      setInit = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isTableScroll = _useState6[0],
      setIsTableScroll = _useState6[1];

  var _useState7 = useState({
    rowIndex: null,
    columnIndex: null
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      selectedCell = _useState8[0],
      setSelectedCell = _useState8[1];

  useEffect(function () {
    // 还需要提供trigger事件,提示用户
    setInit(true);
    var newColumns = computedColumn(columnConfig, columns);

    if ((columnConfig === null || columnConfig === void 0 ? void 0 : columnConfig.length) >= 0) {
      var _state = formatTableStoreInInImmutable(newColumns);

      manager.getActions().updateColumnConfig(_state);
    }

    triggerOnChange({
      type: 'init'
    }, 'fieldConfig');
  }, []);
  useClickAway(function () {
    setSelectedCell({
      rowIndex: null,
      columnIndex: null
    });
  }, internalRefs.bodyInner);

  if (!init) {
    return null;
  }

  _ConfigProvider.config({
    theme: {
      primaryColor: '#02b890'
    }
  });

  return /*#__PURE__*/React.createElement(_ConfigProvider, {
    locale: zhCN
  }, /*#__PURE__*/React.createElement(ArtTableContext.Provider, {
    value: {
      manager: manager
    }
  }, /*#__PURE__*/React.createElement(ArtTableHelpContext.Provider, {
    value: {
      checkedColumnLengthLowerLimit: checkedColumnLengthLowerLimit,
      fixedColumnLengthUpperLimit: fixedColumnLengthUpperLimit,
      sortRulesLengthUpperLimit: sortRulesLengthUpperLimit,
      isTableScroll: isTableScroll,
      isTableColumnResize: isTableColumnResize,
      triggerOnChange: triggerOnChange,
      columns: columns
    }
  }, /*#__PURE__*/React.createElement(ArtTableEditableCellContext.Provider, {
    value: {
      size: size,
      selectedCell: selectedCell
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-wrapper")
  }, /*#__PURE__*/React.createElement(Toolbar, {
    prefixCls: prefixCls,
    slots: toolbarSlots
  }), /*#__PURE__*/React.createElement(_Spin, _objectSpread({
    wrapperClassName: "".concat(prefixCls, "-loading"),
    spinning: false
  }, spinProps), /*#__PURE__*/React.createElement(ExperimentTable, _objectSpread(_objectSpread({}, tableProps), {}, {
    prefixCls: prefixCls,
    className: classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-large"), size === 'large'), _defineProperty(_classNames2, "".concat(prefixCls, "-middle"), size === 'middle'), _defineProperty(_classNames2, "".concat(prefixCls, "-small"), size === 'small'), _defineProperty(_classNames2, "".concat(prefixCls, "-empty"), size === 0), _classNames2)),
    cellExtraRender: cellExtraRender,
    getExtraState: function getExtraState() {
      return _objectSpread(_objectSpread({}, manager.getState()), {}, {
        selectedCell: selectedCell
      });
    },
    rowClassName: internalRowClassName,
    itemHeight: sizeMap.get(size),
    summaryHeight: 33,
    data: pageData,
    columns: computedColumn(columnConfig, columns, true),
    internalRefs: internalRefs,
    onScrollbarStart: function onScrollbarStart() {
      setIsTableScroll(true);
      triggerOnChange({
        isScroll: true
      }, 'tableScroll');
    },
    onScrollbarStop: function onScrollbarStop() {
      setIsTableScroll(false);
      triggerOnChange({
        isScroll: false
      }, 'tableScroll');
    },
    onColumnResizeStart: function onColumnResizeStart() {
      setIsTableColumnResize(true);
    },
    onColumnResizeStop: function onColumnResizeStop(width, uniqueId) {
      var _manager$getState$col, _manager$getState$col2;

      setIsTableColumnResize(false);

      var _ColumnConfig = produce(manager.getState().columnConfig.byId, function (draft) {
        var _index = draft.findIndex(function (s) {
          return s.dataIndex === uniqueId;
        });

        if (_index !== -1) {
          draft[_index].width = width < (draft[_index].minWidth || 96) ? draft[_index].minWidth || 96 : width;
        }
      });

      manager.getActions().updateColumnConfig(_ColumnConfig);
      triggerOnChange({
        column: (_manager$getState$col = manager.getState().columnConfig) === null || _manager$getState$col === void 0 ? void 0 : (_manager$getState$col2 = _manager$getState$col.byId) === null || _manager$getState$col2 === void 0 ? void 0 : _manager$getState$col2.find(function (c) {
          return c.dataIndex === uniqueId;
        })
      }, 'column');
    },
    selectedColor: '#EBF5FF',
    transformColumns: transformColumns,
    emptyText: emptyText,
    onCell: function onCell(_, rowIndex, colIndex) {
      return {
        onClick: function onClick() {
          setSelectedCell({
            rowIndex: rowIndex,
            columnIndex: colIndex
          });
        }
      };
    },
    onHeaderCell: function onHeaderCell(_, rowIndex, colIndex) {
      return {
        onClick: function onClick() {
          setTimeout(function () {
            setSelectedCell({
              rowIndex: rowIndex,
              columnIndex: colIndex
            });
          });
        }
      };
    },
    onSummaryRow: function onSummaryRow() {
      return {
        onClick: function onClick() {
          setSelectedCell({
            rowIndex: null,
            columnIndex: null
          });
        }
      };
    }
  }))), !isGlobalShow && bottomPaginationNode)))));
}

ArtTable.defaultProps = {
  rowKey: 'key',
  size: 'middle',
  summaryHeight: 33,
  checkedColumnLengthLowerLimit: 6,
  fixedColumnLengthUpperLimit: 4,
  sortRulesLengthUpperLimit: 10
};
export default (function (props) {
  var size = props.size,
      columns = props.columns,
      tableInstance = props.tableInstance;
  var manager = tableInstance;

  if (_.isUndefined(tableInstance)) {
    manager = useTable({
      size: size,
      columns: formatTableStoreInInImmutable(columns)
    });
  }

  return /*#__PURE__*/React.createElement(Provider, {
    store: manager.getStore()
  }, /*#__PURE__*/React.createElement(ArtTable, _objectSpread(_objectSpread({}, props), {}, {
    manager: manager
  })));
});