import "antd/es/message/style";
import _message from "antd/es/message";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import classNames from 'classnames';
import { SortableElement, SortableHandle } from 'react-sortable-hoc';
import produce from 'immer';
import _ from 'lodash';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
var DragHandle = SortableHandle(function (_ref) {
  var isDrag = _ref.isDrag,
      isFixed = _ref.isFixed,
      prefixCls = _ref.prefixCls;
  return /*#__PURE__*/React.createElement("i", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item-drag-icon"), "icon-tuodong"),
    style: {
      fontSize: 28,
      marginRight: 2,
      color: isDrag ? '#02B980' : isFixed ? '#BBBBBB' : '#666666',
      cursor: isFixed ? 'pointer' : 'move'
    }
  });
});
export var FieldItem = SortableElement(function (_ref2) {
  var _classNames4, _classNames5;

  var isDrag = _ref2.isDrag,
      isFixed = _ref2.isFixed,
      isHidden = _ref2.isHidden,
      prefixCls = _ref2.prefixCls,
      item = _ref2.item,
      dIndex = _ref2.dIndex;

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      checkedColumnLengthLowerLimit = _useContext2.checkedColumnLengthLowerLimit,
      fixedColumnLengthUpperLimit = _useContext2.fixedColumnLengthUpperLimit,
      triggerOnChange = _useContext2.triggerOnChange;

  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-drag"), isDrag))
  }, /*#__PURE__*/React.createElement(DragHandle, {
    isDrag: isDrag,
    isFixed: isFixed,
    prefixCls: prefixCls
  }), (item === null || item === void 0 ? void 0 : item.icon) && /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item-icon"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-hidden"), isHidden))
  }, item === null || item === void 0 ? void 0 : item.icon), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item-title"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-hidden"), isHidden))
  }, item === null || item === void 0 ? void 0 : item.title), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-field-config-item-right")
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item-right-icon"), "icon-guding", (_classNames4 = {}, _defineProperty(_classNames4, "".concat(prefixCls, "-toolbar-field-config-item-right-icon-fixed"), isFixed), _defineProperty(_classNames4, "".concat(prefixCls, "-toolbar-field-config-item-right-icon-fixed-hidden"), isHidden), _classNames4)),
    style: {
      marginRight: 12
    },
    onClick: function onClick() {
      if (!isHidden) {
        var _ColumnConfig = produce(manager.getState().columnConfig.byId, function (draft) {
          var _draft$dIndex;

          var isUpperLimit = draft.filter(function (v) {
            return v.fixed === 'left' || v.fixed === true;
          }).length >= fixedColumnLengthUpperLimit;

          if (isUpperLimit && ((_draft$dIndex = draft[dIndex]) === null || _draft$dIndex === void 0 ? void 0 : _draft$dIndex.fixed) !== 'left') {
            _message.error("\u6700\u591A\u56FA\u5B9A".concat(fixedColumnLengthUpperLimit, "\u5217!"));
          } else {
            draft[dIndex].fixed = draft[dIndex].fixed === 'left' ? '' : 'left';
            var _item = draft.splice(dIndex, 1)[0];

            var lastFixedIndex = _.findLastIndex(draft, function (v) {
              return v.fixed === 'left';
            });

            draft.splice(lastFixedIndex === -1 ? 0 : lastFixedIndex + 1, 0, _item);
          }
        });

        manager.getActions().updateColumnConfig(_ColumnConfig);
        triggerOnChange({
          type: 'fixed',
          index: dIndex
        }, 'fieldConfig');
      }
    }
  }), /*#__PURE__*/React.createElement("i", {
    className: classNames("".concat(prefixCls, "-toolbar-field-config-item-right-icon"), (_classNames5 = {}, _defineProperty(_classNames5, "icon-uniE945", !isHidden), _defineProperty(_classNames5, 'icon-yincang2', isHidden), _classNames5)),
    onClick: function onClick() {
      var _ColumnConfig = produce(manager.getState().columnConfig.byId, function (draft) {
        var isUpperLimit = draft.filter(function (v) {
          return v.fixed !== 'left' && v.fixed !== 'right' && !v.hidden;
        }).length <= checkedColumnLengthLowerLimit;

        if (isUpperLimit && !isFixed && !isHidden) {
          _message.error("\u975E\u56FA\u5B9A\u5217\u6570\u91CF\u4E0D\u80FD\u5C11\u4E8E".concat(checkedColumnLengthLowerLimit, "\u4E2A!"));
        } else {
          draft[dIndex].hidden = !draft[dIndex].hidden;
        }
      });

      manager.getActions().updateColumnConfig(_ColumnConfig);
      triggerOnChange({
        type: 'hidden',
        index: dIndex
      }, 'fieldConfig');
    }
  })));
});