import React from 'react';
import { SortableContainer } from 'react-sortable-hoc';
import { FieldItem } from './FieldItem';
export var FieldList = SortableContainer(function (_ref) {
  var prefixCls = _ref.prefixCls,
      items = _ref.items,
      dragIndex = _ref.dragIndex;
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-field-config-list")
  }, items.filter(function (item) {
    return item.hiddenColumnConfig !== true;
  }).map(function (v, i) {
    var isDrag = dragIndex === i;
    var isFixed = (v === null || v === void 0 ? void 0 : v.fixed) === 'left';
    var isHidden = (v === null || v === void 0 ? void 0 : v.hidden) === true;
    return /*#__PURE__*/React.createElement(FieldItem, {
      isDrag: isDrag,
      isFixed: isFixed,
      isHidden: isHidden,
      key: v === null || v === void 0 ? void 0 : v.dataIndex,
      index: i,
      dIndex: i,
      prefixCls: prefixCls,
      collection: isFixed ? -1 : 0,
      disabled: isFixed,
      item: v
    });
  }));
});