import "antd/es/space/style";
import _Space from "antd/es/space";
import "antd/es/dropdown/style";
import _Dropdown from "antd/es/dropdown";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useContext } from 'react';
import { arrayMoveMutable } from 'array-move';
import produce from 'immer';
import { useSelector } from 'react-redux';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
import { FieldList } from './FieldList';
import { computedColumn } from '../../utils';

var FieldConfig = function FieldConfig(_ref) {
  var _columnConfig$filter, _columnConfig$filter2;

  var prefixCls = _ref.prefixCls;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useState3 = useState(-1),
      _useState4 = _slicedToArray(_useState3, 2),
      dragIndex = _useState4[0],
      setDragIndex = _useState4[1];

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      columns = _useContext2.columns,
      triggerOnChange = _useContext2.triggerOnChange;

  var columnConfig = useSelector(function (state) {
    return state.columnConfig.byId;
  });
  var itemStyle = visible ? {
    color: '#02B980',
    backgroundColor: '#f2f2f2',
    fontWeight: '500'
  } : {};

  var updateBeforeSortStart = function updateBeforeSortStart(_ref2) {
    var index = _ref2.index;
    setDragIndex(index);
  };

  var onSortEnd = function onSortEnd(_ref3) {
    var oldIndex = _ref3.oldIndex,
        newIndex = _ref3.newIndex;
    setDragIndex(-1);

    var _columnConfig = produce(manager.getState().columnConfig.byId, function (draft) {
      draft = arrayMoveMutable(draft, oldIndex, newIndex);
    });

    manager.getActions().updateColumnConfig(_columnConfig);
    triggerOnChange({
      type: 'move',
      oldIndex: oldIndex,
      newIndex: newIndex
    }, 'fieldConfig');
  };

  return /*#__PURE__*/React.createElement(_Dropdown, {
    overlay: /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-toolbar-field-config-content")
    }, /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-toolbar-field-config-title")
    }, "\u5B57\u6BB5\u914D\u7F6E", /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-toolbar-field-config-limit")
    }, columnConfig === null || columnConfig === void 0 ? void 0 : (_columnConfig$filter = columnConfig.filter(function (c) {
      return (c === null || c === void 0 ? void 0 : c.hidden) !== true && (c === null || c === void 0 ? void 0 : c.hiddenColumnConfig) !== true;
    })) === null || _columnConfig$filter === void 0 ? void 0 : _columnConfig$filter.length, "/", columnConfig === null || columnConfig === void 0 ? void 0 : (_columnConfig$filter2 = columnConfig.filter(function (c) {
      return (c === null || c === void 0 ? void 0 : c.hiddenColumnConfig) !== true;
    })) === null || _columnConfig$filter2 === void 0 ? void 0 : _columnConfig$filter2.length)), /*#__PURE__*/React.createElement(FieldList, {
      prefixCls: prefixCls,
      items: computedColumn(columnConfig, columns),
      updateBeforeSortStart: updateBeforeSortStart,
      dragIndex: dragIndex,
      onSortEnd: onSortEnd,
      useDragHandle: true
    })),
    overlayClassName: "".concat(prefixCls, "-toolbar-field-config-dropdown"),
    trigger: ['click'],
    visible: visible,
    onVisibleChange: function onVisibleChange(v) {
      setVisible(v);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-item"),
    style: _objectSpread({}, itemStyle)
  }, /*#__PURE__*/React.createElement(_Space, {
    size: 7
  }, /*#__PURE__*/React.createElement("i", {
    className: "icon-ziduan"
  }), "\u5B57\u6BB5\u914D\u7F6E")));
};

export default FieldConfig;