import "antd/es/space/style";
import _Space from "antd/es/space";
import "antd/es/dropdown/style";
import _Dropdown from "antd/es/dropdown";
import "antd/es/menu/style";
import _Menu from "antd/es/menu";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useContext } from 'react';
import { useSelector } from 'react-redux';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
var sizeIconMap = {
  small: 'icon-dihanggao',
  middle: 'icon-zhonghanggao',
  large: 'icon-gaohanggao'
};

var LineHeight = function LineHeight(_ref) {
  var prefixCls = _ref.prefixCls;

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var currSize = useSelector(function (state) {
    return state.size;
  });
  var menu = /*#__PURE__*/React.createElement(_Menu, {
    selectedKeys: [currSize],
    onClick: function onClick(_ref2) {
      var key = _ref2.key;
      manager.getActions().updateSize(key);
      triggerOnChange({
        size: key
      }, 'lineHeight');
    },
    items: [{
      key: 'small',
      label: /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-toolbar-line-height-item")
      }, /*#__PURE__*/React.createElement("i", {
        className: "icon-dihanggao"
      }), " \u4F4E")
    }, {
      key: 'middle',
      label: /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-toolbar-line-height-item")
      }, /*#__PURE__*/React.createElement("i", {
        className: "icon-zhonghanggao"
      }), " \u4E2D")
    }, {
      key: 'large',
      label: /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-toolbar-line-height-item")
      }, /*#__PURE__*/React.createElement("i", {
        className: "icon-gaohanggao"
      }), " \u9AD8")
    }]
  });
  var itemStyle = visible ? {
    color: '#02B980',
    backgroundColor: '#f2f2f2',
    fontWeight: '500'
  } : {};
  return /*#__PURE__*/React.createElement(_Dropdown, {
    overlay: menu,
    overlayClassName: "".concat(prefixCls, "-toolbar-line-height-dropdown"),
    trigger: ['click'],
    visible: visible,
    onVisibleChange: function onVisibleChange(v) {
      setVisible(v);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-item"),
    style: _objectSpread({}, itemStyle)
  }, /*#__PURE__*/React.createElement(_Space, {
    size: 6,
    align: "center"
  }, /*#__PURE__*/React.createElement("i", {
    className: sizeIconMap[currSize]
  }), "\u884C\u9AD8")));
};

export default LineHeight;