function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import classNames from 'classnames';
import produce from 'immer';
import { ArtTableContext } from '../../../core/ArtTableContext';
export var ZFButton = function ZFButton(_ref) {
  var rulePrefixCls = _ref.rulePrefixCls,
      checked = _ref.checked,
      dIndex = _ref.dIndex,
      triggerOnChange = _ref.triggerOnChange;

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(rulePrefixCls, "-zf-button")
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(rulePrefixCls, "-button-left"), _defineProperty({}, "".concat(rulePrefixCls, "-button-checked"), !checked)),
    onClick: function onClick() {
      var _sorts = produce(manager.getState().sorts, function (draft) {
        draft[dIndex].rule = 'asc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'trigger',
        rule: 'asc',
        order: dIndex
      }, 'sort', true);
    }
  }, "\u6B63\u5411\u6392\u5E8F"), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(rulePrefixCls, "-button-right"), _defineProperty({}, "".concat(rulePrefixCls, "-button-checked"), checked)),
    onClick: function onClick() {
      var _sorts = produce(manager.getState().sorts, function (draft) {
        draft[dIndex].rule = 'desc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'trigger',
        rule: 'asc',
        order: dIndex
      }, 'sort', true);
    }
  }, "\u5012\u5411\u6392\u5E8F"));
};