import React, { useContext } from 'react';
import classNames from 'classnames';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
export var SortRuleCreateButton = function SortRuleCreateButton(_ref) {
  var prefixCls = _ref.prefixCls,
      firstItem = _ref.firstItem;

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-create")),
    onClick: function onClick() {
      var _firstItem$sort;

      manager.getActions().addSort({
        rule: {
          key: firstItem === null || firstItem === void 0 ? void 0 : firstItem.dataIndex,
          title: (firstItem === null || firstItem === void 0 ? void 0 : firstItem.textTitle) || (firstItem === null || firstItem === void 0 ? void 0 : firstItem.title),
          type: (firstItem === null || firstItem === void 0 ? void 0 : (_firstItem$sort = firstItem.sort) === null || _firstItem$sort === void 0 ? void 0 : _firstItem$sort.type) || 'zf',
          rule: 'desc',
          isDefault: false
        }
      });
      triggerOnChange({
        type: 'add'
      }, 'sort', true);
    }
  }, /*#__PURE__*/React.createElement("i", {
    className: classNames("icon-tianjia"),
    style: {
      fontSize: '24px'
    }
  }), "\u6DFB\u52A0\u6392\u5E8F\u6761\u4EF6");
};