function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import classNames from 'classnames';
import _ from 'lodash';
import { SortableElement, SortableHandle } from 'react-sortable-hoc';
import { useSelector } from 'react-redux';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
import { RuleSwitchHandle } from './RuleButton/RuleSwitchHandle';
import { AZButton } from './RuleButton/AZButton';
import { NumButton } from './RuleButton/NumButton';
import { ZFButton } from './RuleButton/ZFButton';
import { SortSelect } from './SortSelect';
var DragHandle = SortableHandle(function (_ref) {
  var isDrag = _ref.isDrag,
      prefixCls = _ref.prefixCls;
  return /*#__PURE__*/React.createElement("i", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-drag"), "icon-tuodong"),
    style: {
      fontSize: 28,
      marginRight: 6,
      color: isDrag ? '#02B980' : '#666666',
      cursor: 'move'
    }
  });
});
export var SortRuleItem = SortableElement(function (_ref2) {
  var isDrag = _ref2.isDrag,
      prefixCls = _ref2.prefixCls,
      item = _ref2.item,
      dIndex = _ref2.dIndex;

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  var sortSelectList = useSelector(function (state) {
    return state.columnConfig.byId.filter(function (c) {
      return !_.isUndefined(c.sort) && c.sort !== false;
    }).map(function (c) {
      return _objectSpread(_objectSpread({}, c), {}, {
        disabled: !!state.sorts.find(function (s) {
          return s.key === c.dataIndex;
        }),
        title: (c === null || c === void 0 ? void 0 : c.textTitle) || (c === null || c === void 0 ? void 0 : c.title)
      });
    });
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-item"), _defineProperty({}, "".concat(prefixCls, "-toolbar-sort-item-drag"), isDrag))
  }, /*#__PURE__*/React.createElement(DragHandle, {
    isDrag: isDrag,
    prefixCls: prefixCls
  }), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-select"))
  }, (item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-select-default"))
  }, item.title), !(item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/React.createElement(SortSelect, {
    data: sortSelectList,
    item: item,
    dIndex: dIndex,
    prefixCls: prefixCls,
    triggerOnChange: triggerOnChange
  })), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-rule"))
  }, item.type === 'az' && /*#__PURE__*/React.createElement(AZButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), item.type === '09' && /*#__PURE__*/React.createElement(NumButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), item.type === 'zf' && /*#__PURE__*/React.createElement(ZFButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), /*#__PURE__*/React.createElement(RuleSwitchHandle, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule")
  })), !(item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/React.createElement("i", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-delete"), "icon-shanchu4"),
    onClick: function onClick() {
      manager.getActions().removeSort({
        order: dIndex
      });
      triggerOnChange({
        type: 'remove',
        order: dIndex
      }, 'sort', true);
    }
  }), (item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/React.createElement("div", {
    style: {
      marginLeft: '4px',
      width: '24px',
      height: '24px'
    }
  }));
});