import "antd/es/dropdown/style";
import _Dropdown from "antd/es/dropdown";
import "antd/es/menu/style";
import _Menu from "antd/es/menu";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useContext } from 'react';
import classNames from 'classnames';
import produce from 'immer';
import { ArtTableContext } from '../../core/ArtTableContext';
import { ArtTableHelpContext } from '../../core/ArtTableHelpContext';
export var SortSelect = function SortSelect(_ref) {
  var prefixCls = _ref.prefixCls,
      item = _ref.item,
      data = _ref.data,
      dIndex = _ref.dIndex;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useContext = useContext(ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = useContext(ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  var menu = /*#__PURE__*/React.createElement(_Menu, {
    selectedKeys: [item.key],
    onClick: function onClick(_ref2) {
      var key = _ref2.key;

      var _sorts = produce(manager.getState().sorts, function (draft) {
        var _curr$sort;

        var curr = data.find(function (c) {
          return c.dataIndex === key;
        });
        draft[dIndex].key = key;
        draft[dIndex].title = (curr === null || curr === void 0 ? void 0 : curr.textTitle) || (curr === null || curr === void 0 ? void 0 : curr.title);
        draft[dIndex].type = ((_curr$sort = curr.sort) === null || _curr$sort === void 0 ? void 0 : _curr$sort.type) || 'zf';
        draft[dIndex].rule = 'desc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'change',
        index: dIndex
      }, 'sort', true);
    },
    items: data === null || data === void 0 ? void 0 : data.map(function (v) {
      return {
        label: v.title,
        disabled: v === null || v === void 0 ? void 0 : v.disabled,
        key: v.dataIndex
      };
    })
  });
  return /*#__PURE__*/React.createElement(_Dropdown, {
    overlay: menu,
    trigger: ['click'],
    overlayClassName: "".concat(prefixCls, "-toolbar-sort-select-item-dropdown"),
    onVisibleChange: function onVisibleChange(v) {
      setVisible(v);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-select-item"))
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-select-item-title"))
  }, item.title), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-sort-select-item-icon"))
  }, /*#__PURE__*/React.createElement("i", {
    className: visible ? 'icon-shangla' : 'icon-xiala',
    style: {
      fontSize: 24
    }
  }))));
};