import "antd/es/space/style";
import _Space from "antd/es/space";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo } from 'react';
import classNames from 'classnames';
import _ from 'lodash';
import LineHeight from './LineHeight';
import Sort from './Sort';
import FieldConfig from './FieldConfig';
import GlobalShow from './GlobalShow';
import "./index.css";

var Toolbar = function Toolbar(props) {
  var prefixCls = props.prefixCls,
      _props$slots = props.slots,
      slots = _props$slots === void 0 ? [] : _props$slots;
  var defaultSlots = [{
    name: 'fieldConfig',
    position: 'left',
    order: 1,
    render: function render() {
      return /*#__PURE__*/React.createElement(FieldConfig, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldSort',
    position: 'left',
    order: 2,
    render: function render() {
      return /*#__PURE__*/React.createElement(Sort, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldFilter',
    position: 'left',
    order: 3,
    render: function render() {
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-toolbar-item")
      }, /*#__PURE__*/React.createElement(_Space, null, /*#__PURE__*/React.createElement("i", {
        className: "icon-shaixuan"
      }), "\u7B5B\u9009"));
    }
  }, {
    name: 'fieldLineHeight',
    position: 'left',
    order: 4,
    render: function render() {
      return /*#__PURE__*/React.createElement(LineHeight, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldGlobalView',
    position: 'right',
    order: 5,
    render: function render() {
      return /*#__PURE__*/React.createElement(GlobalShow, {
        prefixCls: prefixCls
      });
    }
  }];

  var _useMemo = useMemo(function () {
    var LeftNodes = _.unionBy(slots === null || slots === void 0 ? void 0 : slots.filter(function (slot) {
      return slot.position === 'left';
    }), defaultSlots.slice(0, 4), 'order').sort(function (a, b) {
      return a.order - b.order;
    }),
        RightNodes = _.unionBy(slots === null || slots === void 0 ? void 0 : slots.filter(function (slot) {
      return slot.position === 'right';
    }), defaultSlots.slice(4), 'order').sort(function (a, b) {
      return a.order - b.order;
    });

    return [LeftNodes, RightNodes];
  }, [slots]),
      _useMemo2 = _slicedToArray(_useMemo, 2),
      LeftNodes = _useMemo2[0],
      RightNodes = _useMemo2[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar"))
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-left"))
  }, /*#__PURE__*/React.createElement(_Space, {
    size: 16
  }, LeftNodes.map(function (node) {
    return /*#__PURE__*/React.createElement(React.Fragment, {
      key: node.order
    }, node.render());
  }))), /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefixCls, "-toolbar-right"))
  }, /*#__PURE__*/React.createElement(_Space, {
    size: 16
  }, RightNodes.map(function (node) {
    return /*#__PURE__*/React.createElement(React.Fragment, {
      key: node.order
    }, node.render());
  }))));
};

export default Toolbar;