import { combineFuncs } from '../utils';
import { updateSize } from './size';
import { addColumnConfig, updateColumnConfig, removeColumnConfig, resetColumnConfig } from './columnConfig';
import { addSort, updateSort, removeSort, resetSorts } from './sorts';
import { updateGlobalShow } from './isGlobalShow';
export function createSizeActions(manager) {
  var actions = combineFuncs({
    updateSize: updateSize
  }, manager);
  return actions;
}
export function createColumnConfigActions(manager) {
  var actions = combineFuncs({
    addColumnConfig: addColumnConfig,
    updateColumnConfig: updateColumnConfig,
    removeColumnConfig: removeColumnConfig,
    resetColumnConfig: resetColumnConfig
  }, manager);
  return actions;
}
export function createSortsActions(manager) {
  var actions = combineFuncs({
    addSort: addSort,
    updateSort: updateSort,
    removeSort: removeSort,
    resetSorts: resetSorts
  }, manager);
  return actions;
}
export function createGlobalShowActions(manager) {
  var actions = combineFuncs({
    updateGlobalShow: updateGlobalShow
  }, manager);
  return actions;
}