var _excluded = ["columns"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { default as columnConfigReducer } from './columnConfig';
import { default as sizeReducer } from './size';
import { default as sortsReducer } from './sorts';
import { default as isGlobalShowReducer } from './isGlobalShow';
import _ from 'lodash';
export var initialState = {
  columnConfig: {
    byId: []
  },
  size: 'middle',
  sorts: [],
  isGlobalShow: false
};

function parseDefaultColumnConfig(columns) {
  var byId = columns ? columns === null || columns === void 0 ? void 0 : columns.map(function (c) {
    if (!(c === null || c === void 0 ? void 0 : c.dataIndex)) {
      return;
    }

    return _objectSpread({
      filter: true,
      hidden: false
    }, c);
  }).filter(function (c) {
    return !_.isEmpty(c) && !_.isUndefined(c);
  }) : [];
  return {
    byId: byId
  };
}
/**
 * 计算默认规则即可
 * @param columns
 * @returns
 */


function parseDefaultSorts(columns) {
  var sorts = [];
  columns === null || columns === void 0 ? void 0 : columns.map(function (c) {
    var _c$sort;

    if (c === null || c === void 0 ? void 0 : (_c$sort = c.sort) === null || _c$sort === void 0 ? void 0 : _c$sort.isDefault) {
      var _c$sort2, _c$sort3, _c$sort4;

      sorts.push({
        key: c === null || c === void 0 ? void 0 : c.dataIndex,
        title: (c === null || c === void 0 ? void 0 : c.textTitle) || (c === null || c === void 0 ? void 0 : c.title),
        type: (c === null || c === void 0 ? void 0 : (_c$sort2 = c.sort) === null || _c$sort2 === void 0 ? void 0 : _c$sort2.type) || 'zf',
        rule: (c === null || c === void 0 ? void 0 : (_c$sort3 = c.sort) === null || _c$sort3 === void 0 ? void 0 : _c$sort3.rule) || 'desc',
        isDefault: ((_c$sort4 = c.sort) === null || _c$sort4 === void 0 ? void 0 : _c$sort4.isDefault) || false
      });
    }
  });
  return sorts;
}

export function getInitialState(tableConfig) {
  var columns = tableConfig.columns,
      restConfig = _objectWithoutProperties(tableConfig, _excluded);

  var initColumnConfig = (tableConfig === null || tableConfig === void 0 ? void 0 : tableConfig.columnConfig) || parseDefaultColumnConfig(columns) || {
    byId: []
  };
  return _objectSpread(_objectSpread(_objectSpread({}, initialState), restConfig), {}, {
    sorts: (tableConfig === null || tableConfig === void 0 ? void 0 : tableConfig.sorts) || parseDefaultSorts(initColumnConfig === null || initColumnConfig === void 0 ? void 0 : initColumnConfig.byId),
    columnConfig: initColumnConfig
  });
}
export function artTableReducers() {
  return {
    columnConfig: columnConfigReducer,
    size: sizeReducer,
    sorts: sortsReducer,
    isGlobalShow: isGlobalShowReducer // pagination: pagination(state.pagination, action),

  };
}