function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { createSlice } from '@reduxjs/toolkit';
var sortsSlice = createSlice({
  name: 'sorts',
  initialState: {
    state: []
  },
  reducers: {
    addSort: function addSort(state, action) {
      var _action$payload;

      state.push(_objectSpread({}, (_action$payload = action.payload) === null || _action$payload === void 0 ? void 0 : _action$payload.rule));
    },
    updateSort: function updateSort(state, action) {
      if (action.payload) {
        state = action.payload;
      }

      return state;
    },
    removeSort: function removeSort(state, action) {
      var _action$payload2;

      state.splice((_action$payload2 = action.payload) === null || _action$payload2 === void 0 ? void 0 : _action$payload2.order, 1);
      return state;
    },
    resetSorts: function resetSorts(state, action) {
      var _action$payload3;

      state = (_action$payload3 = action.payload) === null || _action$payload3 === void 0 ? void 0 : _action$payload3.sorts;
      return state;
    }
  }
});
var _sortsSlice$actions = sortsSlice.actions,
    addSort = _sortsSlice$actions.addSort,
    updateSort = _sortsSlice$actions.updateSort,
    removeSort = _sortsSlice$actions.removeSort,
    resetSorts = _sortsSlice$actions.resetSorts;
export { addSort, updateSort, removeSort, resetSorts };
export default sortsSlice.reducer;