/// <reference types="react" />
import { TransformColumns, ColumnsType, ColumnType, ColumnTitleProps, FilterValue, ColumnTitle } from '../../types';
export declare function renderColumnTitle(title: ColumnTitle, icon: ColumnTitle, props: ColumnTitleProps, prefixCls: any): JSX.Element;
export interface FilterState<RecordType> {
    column: ColumnType<RecordType>;
}
interface FilterConfig<RecordType> {
    prefixCls: string;
    isScroll?: boolean;
    mergedColumns: ColumnsType<RecordType>;
    onFilterChange: (filter: Record<string, FilterValue | null>) => void;
}
declare function useFilter<RecordType>({ prefixCls, onFilterChange, }: FilterConfig<RecordType>): [TransformColumns<RecordType>, FilterState<RecordType>[]];
export default useFilter;
