import { configureStore } from '@reduxjs/toolkit';
import { artTableReducers, getInitialState } from '../core/reducers';
import { ArtTableManagerImpl } from '../core/classes/ArtTableManager';
export default function useTable(tableConfig) {
  var store = configureStore({
    reducer: artTableReducers(),
    preloadedState: getInitialState(tableConfig),
    devTools: !!(tableConfig === null || tableConfig === void 0 ? void 0 : tableConfig.devTools)
  });
  var manager = new ArtTableManagerImpl(store);
  return manager;
}