var _excluded = ["onColumnChange", "onResizeStart", "onResizeStop"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from 'react';
export function renderColumnTitle(title, props) {
  var Title = /*#__PURE__*/React.createElement(React.Fragment, null, typeof title === 'function' ? title(props) : title);
  return Title;
}

function fillTitle(columns, columnTitleProps, manager) {
  var onColumnChange = columnTitleProps.onColumnChange,
      onResizeStart = columnTitleProps.onResizeStart,
      onResizeStop = columnTitleProps.onResizeStop,
      rest = _objectWithoutProperties(columnTitleProps, _excluded);

  return columns.map(function (column) {
    var cloneColumn = _objectSpread({}, column);

    var isResize = (column === null || column === void 0 ? void 0 : column.resize) !== false;
    cloneColumn.title = renderColumnTitle(column.title, rest);

    if ('children' in cloneColumn) {
      cloneColumn.children = fillTitle(cloneColumn.children, rest, manager);
    }

    if (isResize) {
      cloneColumn.onHeaderCell = function (c) {
        return {
          width: c.width,

          /* onResizeStart: (uniqueId: any) => {
            onResizeStart(uniqueId);
          },
          onResizeStop: (width: any, uniqueId: any) => {
            const _ColumnConfig = produce(manager.getState().columnConfig.byId, (draft: any) => {
              const _index = draft.findIndex((s: any) => s.dataIndex === uniqueId);
                       if (_index !== -1) {
                draft[_index].width = width;
              }
            });
                     manager.getActions().updateColumnConfig(_ColumnConfig);
                     onColumnChange(c);
            onResizeStop(width, uniqueId);
          }, */
          axis: 'x'
        };
      };
    }

    return cloneColumn;
  });
}

export default function useTitleColumns(manager, columnTitleProps) {
  var filledColumns = React.useCallback(function (columns) {
    return fillTitle(columns, columnTitleProps, manager);
  }, [columnTitleProps]);
  return [filledColumns];
}