import * as React from 'react';
import type { GetComponentProps, GetCellComponentProps, Key, GetRowKey } from '../types';
export interface BodyRowProps<RecordType> {
    record: RecordType;
    index: number;
    renderIndex: number;
    className?: string;
    style?: React.CSSProperties;
    recordKey: Key;
    onRow: GetComponentProps<RecordType>;
    onCell: GetCellComponentProps<RecordType>;
    indent?: number;
    rowKey: React.Key;
    getRowKey: GetRowKey<RecordType>;
}
declare function BodyRow<RecordType extends {
    children?: readonly RecordType[];
}>(props: BodyRowProps<RecordType>): JSX.Element;
declare namespace BodyRow {
    var displayName: string;
}
export default BodyRow;
