function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import ResizeObserver from 'rc-resize-observer'; // import SortableBox from '../Header/SortableBox';

import TableContext from '../context/TableContext';
import BodyContext from '../context/BodyContext';
export default function MeasureCell(_ref) {
  var cellWidth = _ref.cellWidth,
      columnKey = _ref.columnKey,
      onColumnResize = _ref.onColumnResize,
      fixLeft = _ref.fixLeft,
      fixRight = _ref.fixRight;
  var cellRef = React.useRef();

  var _React$useContext = React.useContext(TableContext),
      viewMaxHeight = _React$useContext.viewMaxHeight;

  var _React$useContext2 = React.useContext(BodyContext),
      flattenColumns = _React$useContext2.flattenColumns; // const linePrefixCls = `${prefixCls}-line`;


  var item = flattenColumns.find(function (column) {
    return column.dataIndex === columnKey;
  }); // ====================== Fixed =======================

  var fixedStyle = {};
  var isFixLeft = typeof fixLeft === 'number';
  var isFixRight = typeof fixRight === 'number';

  if (isFixLeft) {
    fixedStyle.position = 'sticky';
    fixedStyle.left = fixLeft;
    fixedStyle.zIndex = 29;
  }

  if (isFixRight) {
    fixedStyle.position = 'sticky';
    fixedStyle.right = fixRight;
    fixedStyle.zIndex = 29;
  }

  React.useEffect(function () {
    if (cellRef.current) {
      onColumnResize(columnKey, cellRef.current.offsetWidth);
    }
  }, []);
  return /*#__PURE__*/React.createElement(ResizeObserver, {
    data: columnKey
  }, /*#__PURE__*/React.createElement("div", {
    ref: cellRef,
    style: _objectSpread({
      padding: 0,
      border: 0,
      height: viewMaxHeight,
      flex: (item === null || item === void 0 ? void 0 : item.flex) === false ? '0 0 auto' : '1 0 auto',
      minWidth: (item === null || item === void 0 ? void 0 : item.minWidth) || 96,
      width: cellWidth,
      position: 'relative',
      zIndex: 20,
      backgroundColor: '#fff'
    }, fixedStyle)
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      height: 0,
      overflow: 'hidden'
    }
  }, "\xA0")));
}