function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import ResizeObserver from 'rc-resize-observer';
import MeasureCell from './MeasureCell';
import BodyContext from '../context/BodyContext';
import TableContext from '../context/TableContext';
import { getCellWidth, parseHeaderRows } from '../utils/valueUtil';
export default function MeasureRow(_ref) {
  var prefixCls = _ref.prefixCls,
      columnsKey = _ref.columnsKey,
      onColumnResize = _ref.onColumnResize;

  var _React$useContext = React.useContext(TableContext),
      fixedInfoList = _React$useContext.fixedInfoList;

  var _React$useContext2 = React.useContext(BodyContext),
      flattenColumns = _React$useContext2.flattenColumns;

  var rows = React.useMemo(function () {
    return parseHeaderRows(flattenColumns)[0];
  }, [flattenColumns]);
  var colWidths = flattenColumns.map(function (_ref2) {
    var width = _ref2.width;
    return width;
  });
  return /*#__PURE__*/React.createElement("div", {
    "aria-hidden": "true",
    className: "".concat(prefixCls, "-measure-row"),
    style: {
      height: 0,
      fontSize: 0,
      display: 'flex'
    }
  }, /*#__PURE__*/React.createElement(ResizeObserver.Collection, {
    onBatchResize: function onBatchResize(infoList) {
      infoList.forEach(function (_ref3) {
        var columnKey = _ref3.data,
            size = _ref3.size;
        onColumnResize(columnKey, size.offsetWidth);
      });
    }
  }, columnsKey.map(function (columnKey, index) {
    var beginRow = rows[index];
    var fixedInfo = fixedInfoList[index];
    var cellWidth = getCellWidth(beginRow.colStart, beginRow.colSpan, colWidths);
    return /*#__PURE__*/React.createElement(MeasureCell, _objectSpread(_objectSpread({
      cellWidth: cellWidth,
      key: columnKey
    }, fixedInfo), {}, {
      columnKey: columnKey,
      onColumnResize: onColumnResize
    }));
  })));
}