/// <reference types="react" />
import type { CellType, StickyOffsets, ColumnType, GetComponentProps } from '../types';
export interface RowProps<RecordType> {
    cells: readonly CellType<RecordType>[];
    stickyOffsets: StickyOffsets;
    flattenColumns: readonly ColumnType<RecordType>[];
    onSummaryRow: GetComponentProps<readonly ColumnType<RecordType>[]>;
    index: number;
    colWidths: readonly (number | string)[];
}
declare function SummaryRow<RecordType>({ cells, stickyOffsets, flattenColumns, onSummaryRow, index, colWidths, }: RowProps<RecordType>): JSX.Element;
declare namespace SummaryRow {
    var displayName: string;
}
export default SummaryRow;
