function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from 'react';
import Cell from '../Cell';
import TableContext from '../context/TableContext';
import { getCellFixedInfo } from '../utils/fixUtil';
import { getColumnsKey, getCellWidth } from '../utils/valueUtil';

function SummaryRow(_ref) {
  var cells = _ref.cells,
      stickyOffsets = _ref.stickyOffsets,
      flattenColumns = _ref.flattenColumns,
      onSummaryRow = _ref.onSummaryRow,
      index = _ref.index,
      colWidths = _ref.colWidths;

  var _React$useContext = React.useContext(TableContext),
      prefixCls = _React$useContext.prefixCls,
      direction = _React$useContext.direction;

  var rowProps;

  if (onSummaryRow) {
    rowProps = onSummaryRow(cells.map(function (cell) {
      return cell.column;
    }), index);
  }

  var columnsKey = getColumnsKey(cells.map(function (cell) {
    return cell.column;
  }));
  return /*#__PURE__*/React.createElement("div", _objectSpread(_objectSpread({
    className: "".concat(prefixCls, "-summary-row")
  }, rowProps), {}, {
    style: {
      display: 'flex'
    }
  }), cells.map(function (cell, cellIndex) {
    var column = cell.column;
    var fixedInfo = getCellFixedInfo(cell.colStart, cell.colEnd, flattenColumns, stickyOffsets, direction);
    var cellWidth = getCellWidth(cell.colStart, cell.colSpan, colWidths);
    var additionalProps;

    if (column && column.onSummaryCell) {
      var _cell$column;

      additionalProps = cell === null || cell === void 0 ? void 0 : (_cell$column = cell.column) === null || _cell$column === void 0 ? void 0 : _cell$column.onSummaryCell(column);
    }

    return /*#__PURE__*/React.createElement(Cell, _objectSpread(_objectSpread(_objectSpread({}, cell), {}, {
      cellWidth: cellWidth,
      isFooter: true,
      summaryRender: column === null || column === void 0 ? void 0 : column.summaryRender,
      ellipsis: column === null || column === void 0 ? void 0 : column.ellipsis,
      align: column === null || column === void 0 ? void 0 : column.align,
      prefixCls: prefixCls,
      key: columnsKey[cellIndex]
    }, fixedInfo), {}, {
      additionalProps: _objectSpread(_objectSpread({}, additionalProps), {}, {
        style: {
          flex: (column === null || column === void 0 ? void 0 : column.flex) === false ? '0 0 auto' : '1 0 auto',
          minWidth: (column === null || column === void 0 ? void 0 : column.minWidth) || 96
        }
      }),
      rowType: "footer"
    }));
  }));
}

SummaryRow.displayName = 'HeaderRow';
export default SummaryRow;