import * as React from 'react';
import TableContext from '../context/TableContext';
import SummaryRow from './SummaryRow';
import { parseFooterRows } from '../utils/valueUtil';

function Footer(_ref) {
  var data = _ref.data,
      stickyOffsets = _ref.stickyOffsets,
      columns = _ref.columns,
      colWidths = _ref.colWidths,
      flattenColumns = _ref.flattenColumns,
      columCount = _ref.columCount,
      onSummaryRow = _ref.onSummaryRow;
  var tableContext = React.useContext(TableContext);
  var prefixCls = tableContext.prefixCls,
      summaryHeight = tableContext.summaryHeight;
  var rows = React.useMemo(function () {
    return parseFooterRows(columns, data);
  }, [columns]);

  if (columCount <= 0) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-summary-container"),
    style: {
      height: summaryHeight
    }
  }, rows.map(function (row, rowIndex) {
    var rowNode = /*#__PURE__*/React.createElement(SummaryRow, {
      colWidths: colWidths,
      key: rowIndex,
      flattenColumns: flattenColumns,
      cells: row,
      stickyOffsets: stickyOffsets,
      onSummaryRow: onSummaryRow,
      index: rowIndex
    });
    return rowNode;
  }));
}

export default Footer;