import * as React from 'react';
import type { ColumnsType, StickyOffsets, ColumnType, GetComponentProps, GetCellComponentProps } from '../types';
export interface HeaderProps<RecordType> {
    columns: ColumnsType<RecordType>;
    flattenColumns: readonly ColumnType<RecordType>[];
    stickyOffsets: StickyOffsets;
    onHeaderCell: GetCellComponentProps<RecordType>;
    onHeaderRow: GetComponentProps<readonly ColumnType<RecordType>[]>;
}
export interface HeaderInnerProps {
    colWidths: readonly (number | string)[];
    columCount?: number;
    isScroll?: boolean;
    scrollBodyTranslateX?: number;
}
declare function Header<RecordType>({ stickyOffsets, columns, flattenColumns, onHeaderCell, onHeaderRow, colWidths, columCount, scrollBodyTranslateX, }: HeaderProps<RecordType> & HeaderInnerProps): React.ReactElement;
export default Header;
