import * as React from 'react';
import HeaderRow from './HeaderRow';
import TableContext from '../context/TableContext';
import { parseHeaderRows } from '../utils/valueUtil';

function Header(_ref) {
  var stickyOffsets = _ref.stickyOffsets,
      columns = _ref.columns,
      flattenColumns = _ref.flattenColumns,
      onHeaderCell = _ref.onHeaderCell,
      onHeaderRow = _ref.onHeaderRow,
      colWidths = _ref.colWidths,
      columCount = _ref.columCount,
      scrollBodyTranslateX = _ref.scrollBodyTranslateX;

  var _React$useContext = React.useContext(TableContext),
      prefixCls = _React$useContext.prefixCls;

  var rows = React.useMemo(function () {
    return parseHeaderRows(columns);
  }, [columns]);

  if (columCount <= 0) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-thead")
  }, rows.map(function (row, rowIndex) {
    var rowNode = /*#__PURE__*/React.createElement(HeaderRow, {
      colWidths: colWidths,
      key: rowIndex,
      flattenColumns: flattenColumns,
      cells: row,
      stickyOffsets: stickyOffsets,
      onHeaderCell: onHeaderCell,
      onHeaderRow: onHeaderRow,
      scrollBodyTranslateX: scrollBodyTranslateX,
      index: rowIndex
    });
    return rowNode;
  }));
}

export default Header;