function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as React from 'react';
import classNames from 'classnames';
import ResizeableBox from './ResizeableBox';
import ResizeableBoxHelper from './ResizeableBoxHelper';
import Cell from '../Cell';
import TableContext from '../context/TableContext';
import { getCellFixedInfo } from '../utils/fixUtil';
import { getColumnsKey, getCellWidth } from '../utils/valueUtil'; // import { getParent, isMouseEvent, isTouchEvent } from '../utils/resizeUtil';

import SortableBox from './SortableBox';
import SortableBoxHelper from './SortableBoxHelper';

function HeaderRow(_ref) {
  var _getExtraState;

  var cells = _ref.cells,
      stickyOffsets = _ref.stickyOffsets,
      flattenColumns = _ref.flattenColumns,
      onHeaderCell = _ref.onHeaderCell,
      onHeaderRow = _ref.onHeaderRow,
      index = _ref.index,
      colWidths = _ref.colWidths,
      scrollBodyTranslateX = _ref.scrollBodyTranslateX;

  var _React$useContext = React.useContext(TableContext),
      prefixCls = _React$useContext.prefixCls,
      direction = _React$useContext.direction,
      pingedLeft = _React$useContext.pingedLeft,
      pingedRight = _React$useContext.pingedRight,
      onColumnResizeStart = _React$useContext.onColumnResizeStart,
      onColumnResizeStop = _React$useContext.onColumnResizeStop,
      getExtraState = _React$useContext.getExtraState,
      isScroll = _React$useContext.isScroll,
      selectedColor = _React$useContext.selectedColor,
      sortableStore = _React$useContext.sortableStore,
      sortableDispatch = _React$useContext.sortableDispatch;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      isHoverResize = _React$useState2[0],
      setIsHoverResize = _React$useState2[1];

  var _React$useState3 = React.useState(0),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      columnOffsetLeft = _React$useState4[0],
      setColumnOffsetLeft = _React$useState4[1]; // 给后续冻结使用


  var _React$useState5 = React.useState(false),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      isColumnResize = _React$useState6[0],
      setIsColumnResize = _React$useState6[1];

  var _React$useState7 = React.useState(null),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      columnResizeKey = _React$useState8[0],
      setColumnResizeKey = _React$useState8[1]; // 给拖拽排序使用


  var _React$useState9 = React.useState(0),
      _React$useState10 = _slicedToArray(_React$useState9, 1),
      initX = _React$useState10[0]; // const dragSortRef = React.useRef();


  var rowProps;

  if (onHeaderRow) {
    rowProps = onHeaderRow(cells.map(function (cell) {
      return cell.column;
    }), index);
  }

  var columnsKey = getColumnsKey(cells.map(function (cell) {
    return cell.column;
  }));
  var linePrefixCls = "".concat(prefixCls, "-line");
  var headerCellPrefixCls = "".concat(prefixCls, "-header-cell");
  var selectedCell = (_getExtraState = getExtraState()) === null || _getExtraState === void 0 ? void 0 : _getExtraState.selectedCell;
  var isSelectedRow = (selectedCell === null || selectedCell === void 0 ? void 0 : selectedCell.rowIndex) < 0;
  React.useEffect(function () {
    if (isScroll) {
      setIsHoverResize(false);
      setIsColumnResize(false);
    }
  }, [isScroll]);
  return /*#__PURE__*/React.createElement("div", _objectSpread(_objectSpread({
    className: "".concat(prefixCls, "-row")
  }, rowProps), {}, {
    style: {
      display: 'flex'
    }
  }), cells.map(function (cell, cellIndex) {
    var _classNames, _classNames2, _classNames4;

    var _ref2 = cell || {},
        column = _ref2.column;

    var fixedInfo = getCellFixedInfo(cell.colStart, cell.colEnd, flattenColumns, stickyOffsets, direction);
    var scrollStyle = {};
    var isFixLeft = typeof fixedInfo.fixLeft === 'number';
    var isFixRight = typeof fixedInfo.fixRight === 'number';

    if (!isFixLeft && !isFixRight) {
      scrollStyle.transform = "translateX(-".concat(scrollBodyTranslateX, "px)");
    }

    var isResize = (column === null || column === void 0 ? void 0 : column.resize) !== false;
    var isSortable = (column === null || column === void 0 ? void 0 : column.sortable) !== false;
    var cellWidth = getCellWidth(cell.colStart, cell.colSpan, colWidths);
    var additionalProps;

    if (column && column.onHeaderCell) {
      var _cell$column;

      additionalProps = cell === null || cell === void 0 ? void 0 : (_cell$column = cell.column) === null || _cell$column === void 0 ? void 0 : _cell$column.onHeaderCell(column);
    }

    var isSelectedCell = isSelectedRow && (selectedCell === null || selectedCell === void 0 ? void 0 : selectedCell.columnIndex) === cellIndex;
    return /*#__PURE__*/React.createElement(Cell, _objectSpread(_objectSpread(_objectSpread({}, cell), {}, {
      cellWidth: cellWidth,
      ellipsis: column === null || column === void 0 ? void 0 : column.ellipsis,
      align: 'left',
      prefixCls: prefixCls,
      key: columnsKey[cellIndex],
      component: 'div'
    }, fixedInfo), {}, {
      _classNames: (_classNames = {}, _defineProperty(_classNames, "".concat(headerCellPrefixCls, "-").concat(columnsKey[cellIndex]), true), _defineProperty(_classNames, "".concat(headerCellPrefixCls, "-selected"), isSelectedCell), _classNames),
      additionalProps: _objectSpread(_objectSpread({}, additionalProps), {}, {
        style: _objectSpread({
          flex: (column === null || column === void 0 ? void 0 : column.flex) === false ? '0 0 auto' : '1 0 auto',
          minWidth: (column === null || column === void 0 ? void 0 : column.minWidth) || 96,
          backgroundColor: isSelectedCell ? selectedColor : '#F7F8F8'
        }, scrollStyle),
        onMouseDown: function onMouseDown(e) {
          e.persist();
          /* if (isSelectedCell) {
            const el = getParent(e.target, `.${headerCellPrefixCls}-selected`)[0];
                     dragSortRef.current = el;
                     if (e?.nativeEvent && isMouseEvent(e?.nativeEvent)) {
              setInitX(e?.nativeEvent.clientX);
            } else if (e?.nativeEvent && isTouchEvent(e?.nativeEvent)) {
              setInitX((e?.nativeEvent as TouchEvent)?.touches[0]?.clientX);
            }
                     sortableDispatch({ type: 'setIsColumnSort', payload: { isColumnSort: true } });
                     sortableDispatch({
              type: 'setColumnDragSortKey',
              payload: { columnDragSortKey: columnsKey[cellIndex] },
            });
          } */
        },
        prefixCls: prefixCls
      }),
      appendNode: /*#__PURE__*/React.createElement(React.Fragment, null, isResize && /*#__PURE__*/React.createElement(ResizeableBox, {
        onMouseEnter: function onMouseEnter(offsetLeft) {
          if (!isColumnResize) {
            setIsHoverResize(true);
            setColumnResizeKey(columnsKey[cellIndex]);
            setColumnOffsetLeft(offsetLeft);
          }
        },
        className: "".concat(linePrefixCls, "-resize")
      }), isSortable && sortableStore.isColumnSort && /*#__PURE__*/React.createElement(SortableBox, {
        className: "".concat(linePrefixCls, "-sortable"),
        columnDragSortKey: sortableStore.columnDragSortKey,
        currDropSortKey: sortableStore.columnDropSortKey,
        onDrop: function onDrop(pKey) {
          sortableDispatch({
            type: 'setColumnDropSortKey',
            payload: {
              columnDropSortKey: pKey
            }
          });
        },
        pKey: columnsKey[cellIndex]
      }), isFixLeft && !pingedLeft && fixedInfo.lastFixLeft && /*#__PURE__*/React.createElement("div", {
        className: classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(linePrefixCls, "-fix-left"), isFixLeft), _defineProperty(_classNames2, "".concat(linePrefixCls, "-fix-left-first"), fixedInfo.firstFixLeft), _defineProperty(_classNames2, "".concat(linePrefixCls, "-fix-left-last-border"), fixedInfo.lastFixLeft), _defineProperty(_classNames2, "".concat(linePrefixCls, "-fix-sticky"), isFixLeft || isFixRight), _classNames2))
      }), isFixLeft && pingedLeft && fixedInfo.lastFixLeft && /*#__PURE__*/React.createElement("div", {
        className: classNames(linePrefixCls, _defineProperty({}, "".concat(linePrefixCls, "-fix-left-last"), fixedInfo.lastFixLeft))
      }), isFixRight && !pingedRight && fixedInfo.firstFixRight && /*#__PURE__*/React.createElement("div", {
        className: classNames((_classNames4 = {}, _defineProperty(_classNames4, "".concat(linePrefixCls, "-fix-right"), isFixRight), _defineProperty(_classNames4, "".concat(linePrefixCls, "-fix-right-last"), fixedInfo.lastFixRight), _defineProperty(_classNames4, "".concat(linePrefixCls, "-fix-right-first-border"), fixedInfo.firstFixRight), _defineProperty(_classNames4, "".concat(linePrefixCls, "-fix-sticky"), isFixLeft || isFixRight), _classNames4))
      }), isFixRight && pingedRight && fixedInfo.firstFixRight && /*#__PURE__*/React.createElement("div", {
        className: classNames(linePrefixCls, _defineProperty({}, "".concat(linePrefixCls, "-fix-right-first"), fixedInfo.firstFixRight))
      })),
      onCellClick: function onCellClick(event) {
        var _onHeaderCell;

        (_onHeaderCell = onHeaderCell(column, index - 1, cellIndex)) === null || _onHeaderCell === void 0 ? void 0 : _onHeaderCell.onClick(event);
      },
      isSelectedCell: isSelectedCell,
      rowType: "header"
    }));
  }), isHoverResize && /*#__PURE__*/React.createElement(ResizeableBoxHelper, {
    cellPrefixCls: headerCellPrefixCls,
    className: "".concat(linePrefixCls, "-resize-helper"),
    offsetLeft: columnOffsetLeft,
    isColumnResize: isColumnResize,
    onResizeStart: onColumnResizeStart,
    onResizeStop: onColumnResizeStop,
    setIsHoverResize: setIsHoverResize,
    setIsColumnResize: setIsColumnResize,
    pKey: columnResizeKey
  }), sortableStore.isColumnSort && /*#__PURE__*/React.createElement(SortableBoxHelper, {
    cellPrefixCls: headerCellPrefixCls,
    className: "".concat(linePrefixCls, "-sortable-helper"),
    onDragStart: function onDragStart() {},
    onDragEnd: function onDragEnd() {
      sortableDispatch({
        type: 'setIsColumnSort',
        payload: {
          isColumnSort: false
        }
      });
      sortableDispatch({
        type: 'setColumnDragSortKey',
        payload: {
          columnDragSortKey: null
        }
      });
    },
    initX: initX,
    pKey: sortableStore.columnDragSortKey
  }));
}

HeaderRow.displayName = 'HeaderRow';
export default HeaderRow;