import React, { useRef } from 'react';
import classNames from 'classnames';
import { getElementLeft, getParent } from '../utils/resizeUtil';

var ResizeableTitle = function ResizeableTitle(props) {
  var className = props.className,
      _onMouseEnter = props.onMouseEnter;
  var resizeRef = useRef();
  return /*#__PURE__*/React.createElement("div", {
    onMouseEnter: function onMouseEnter() {
      var parent = getParent(resizeRef.current, '.kodo-art-table-row')[0];
      var offsetLeft = getElementLeft(parent, resizeRef.current);

      _onMouseEnter(offsetLeft);
    },
    className: classNames("".concat(className)),
    ref: resizeRef
  });
};

export default ResizeableTitle;