function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState, useRef } from 'react';
import classNames from 'classnames';
import { isTouchEvent, getParent, getElementLeft } from '../utils/resizeUtil';

var SortableBoxHelper = function SortableBoxHelper(props) {
  var initX = props.initX,
      cellPrefixCls = props.cellPrefixCls,
      className = props.className,
      pKey = props.pKey,
      onDragStart = props.onDragStart,
      onDragEnd = props.onDragEnd;

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      deltaX = _useState2[0],
      setDeltaX = _useState2[1];

  var _useState3 = useState(0),
      _useState4 = _slicedToArray(_useState3, 2),
      columnWidth = _useState4[0],
      setColumnWidth = _useState4[1];

  var _useState5 = useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      offsetLeft = _useState6[0],
      setOffsetLeft = _useState6[1];

  var sortableRef = useRef();
  var columnClassName = ".".concat(cellPrefixCls, "-").concat(pKey);

  var onMouseMove = function onMouseMove(event) {
    if (window.TouchEvent && isTouchEvent(event)) {
      try {
        event.preventDefault();
        event.stopPropagation();
      } catch (e) {// Ignore on fail
      }
    }

    var _clientX = isTouchEvent(event) ? event.touches[0].clientX : event.clientX;

    var _deltaX = _clientX - initX || 0;

    setDeltaX(_deltaX);
  };

  var onMouseUp = function onMouseUp() {
    setDeltaX(0);
    onDragEnd();
  };

  useEffect(function () {
    if (window) {
      window.addEventListener('mousemove', onMouseMove);
      window.addEventListener('touchmove', onMouseMove, {
        capture: true,
        passive: false
      });
      window.addEventListener('mouseup', onMouseUp);
      window.addEventListener('mouseleave', onMouseUp);
      setDeltaX(0);
      var columnEl = document.querySelector(columnClassName);
      var parentRect = columnEl === null || columnEl === void 0 ? void 0 : columnEl.getBoundingClientRect();
      var parent = getParent(columnEl, '.kodo-art-table-row')[0];

      var _offsetLeft = getElementLeft(parent, columnEl);

      setColumnWidth((parentRect === null || parentRect === void 0 ? void 0 : parentRect.width) || 0);
      setOffsetLeft(_offsetLeft);
      onDragStart(pKey);
    }

    return function () {
      if (window) {
        window.removeEventListener('mousemove', onMouseMove);
        window.removeEventListener('touchmove', onMouseMove, true);
        window.removeEventListener('mouseup', onMouseUp);
        window.removeEventListener('mouseleave', onMouseUp);
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    onMouseUp: onMouseUp,
    className: classNames("".concat(className)),
    ref: sortableRef,
    style: {
      width: columnWidth,
      left: offsetLeft + deltaX
    }
  });
};

export default SortableBoxHelper;