import React from 'react';
import './index.less';
export declare type Pos = {
    top: number;
    left: number;
    bottom: number;
    right: number;
};
interface State {
    showVeriticalTrack: boolean;
    showHorizontalTrack: boolean;
    scrollbarWidth: number;
    noselect: boolean;
    handlerPos: Pos;
    hideHandler: boolean;
}
export declare type StartOption = '' | 'bottom' | 'right' | 'bottom right' | {
    top: number;
    left: number;
};
export interface Props {
    className?: string;
    style?: object;
    fixed?: boolean;
    autoHide?: boolean;
    timeout?: number;
    trackSize?: string;
    fixedOffset?: any;
    start?: StartOption;
    dataSource?: any;
    showData?: any;
    browserOffset?: string;
    onScrollbarScroll?: (pos: any) => void;
    onScrollbarStart?: () => void;
    onScrollbarStop?: () => void;
    onScrollbarScrollTimeout?: number;
}
export default class Scrollbar extends React.PureComponent<Props, State> {
    protected static displayName: string;
    static defaultProps: Props;
    private scrolling;
    private detectScrollingInterval;
    private lastViewScrollLeft;
    private lastViewScrollTop;
    private el;
    private offsetHeight;
    private offsetWidth;
    private lastScrollHeight;
    private lastScrollWidth;
    private activeHandler;
    private lastMousePos;
    private lastContainerScrollTop;
    private lastContainerScrollLeft;
    private handlerHider;
    constructor(props: Props);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: any): void;
    private handleReadyStateChange;
    private prepareScrollbar;
    private prepareScrollbarStartPos;
    private collectInfo;
    private updateTrackVisibilities;
    private resetHandlerHider;
    private handleScrollStart;
    private handleScrollStop;
    private handlerContainerScroll;
    private detectScrolling;
    private handleHandlerMouseDown;
    private handleHandlerMouseMove;
    private handleHandlerMouseUp;
    /**
     * Set the scrolling position manually.
     */
    setPosition: (pos: {
        top?: number;
        left?: number;
    }) => void;
    getScrolling: () => boolean;
    render(): JSX.Element;
}
export {};
