function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React from 'react';
import _ from 'lodash';
import { getScrollbarWidth } from './utils';
import "./index.css";
var Direction;

(function (Direction) {
  Direction[Direction["Vertical"] = 0] = "Vertical";
  Direction[Direction["Horizontal"] = 1] = "Horizontal";
})(Direction || (Direction = {}));

var styles = {
  main: {
    overflow: 'hidden',
    position: 'relative',
    boxSizing: 'border-box'
  },
  container: {
    position: 'absolute',
    top: '0',
    left: '0',
    overflow: 'scroll',
    boxSizing: 'border-box'
  },
  track: {
    vertical: {
      position: 'absolute',
      right: '0'
    },
    verticalCustomize: {
      width: '10px',
      backgroundColor: '#FAFAFA',
      borderLeft: '1px solid #E8E8E8',
      transition: 'opacity 0.3s'
    },
    horizontal: {
      position: 'absolute',
      bottom: '0'
    },
    horizontalCustomize: {
      height: '10px',
      backgroundColor: '#FAFAFA',
      borderTop: '1px solid #E8E8E8',
      transition: 'opacity 0.3s'
    }
  },
  handler: {
    vertical: {
      position: 'absolute'
    },
    verticalCustomize: {
      width: '100%',
      backgroundColor: '#C1C1C1',
      borderRadius: '5px',
      transition: 'opacity 0.3s'
    },
    horizontal: {
      position: 'absolute'
    },
    horizontalCustomize: {
      height: '100%',
      backgroundColor: '#C1C1C1',
      borderRadius: '5px',
      transition: 'opacity 0.3s'
    }
  },
  square: {
    position: 'absolute',
    width: '10px',
    height: '10px',
    right: 0,
    bottom: 0,
    backgroundColor: 'white'
  }
};

var Scrollbar = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Scrollbar, _React$PureComponent);

  var _super = _createSuper(Scrollbar);

  function Scrollbar(props) {
    var _this;

    _classCallCheck(this, Scrollbar);

    _this = _super.call(this, props);
    _this.scrolling = false;
    _this.detectScrollingInterval = null;
    _this.lastViewScrollLeft = null;
    _this.lastViewScrollTop = null;
    _this.el = null;
    _this.offsetHeight = 0;
    _this.offsetWidth = 0;
    _this.lastScrollHeight = 0;
    _this.lastScrollWidth = 0;
    _this.activeHandler = null;
    _this.lastMousePos = null;
    _this.lastContainerScrollTop = 0;
    _this.lastContainerScrollLeft = 0;
    _this.handlerHider = null;

    _this.handleReadyStateChange = function () {
      if (document.readyState === 'complete') {
        _this.prepareScrollbar();

        _this.prepareScrollbarStartPos();
      }
    };

    _this.prepareScrollbar = function () {
      _this.collectInfo();

      _this.updateTrackVisibilities();

      _this.setState({
        scrollbarWidth: getScrollbarWidth()
      }); // Trigger auto hider.


      _this.handlerContainerScroll();
    };

    _this.prepareScrollbarStartPos = function () {
      var start = _this.props.start;

      if (typeof start === 'string') {
        if (start.includes('bottom')) {
          _this.el.scrollTop = _this.el.scrollHeight;
        }

        if (start.includes('right')) {
          _this.el.scrollLeft = _this.el.scrollWidth;
        }
      } else if (_typeof(start) === 'object') {
        _this.el.scrollTop = start.top;
        _this.el.scrollLeft = start.left;
      }
    };

    _this.collectInfo = function () {
      _this.offsetWidth = _this.el.offsetWidth;
      _this.offsetHeight = _this.el.offsetHeight;
    };

    _this.updateTrackVisibilities = function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          el = _assertThisInitialize.el;

      var scrollHeight = el.scrollHeight,
          scrollWidth = el.scrollWidth;
      if (scrollHeight === _this.lastScrollHeight && scrollWidth === _this.lastScrollWidth) return;

      _this.setState({
        showVeriticalTrack: scrollHeight > _this.offsetHeight,
        showHorizontalTrack: scrollWidth > _this.offsetWidth
      });

      _this.lastScrollWidth = scrollWidth;
      _this.lastScrollHeight = scrollHeight;
    };

    _this.resetHandlerHider = function () {
      if (_this.props.autoHide) {
        clearTimeout(_this.handlerHider);

        _this.setState({
          hideHandler: false
        });

        _this.handlerHider = setTimeout(function () {
          _this.setState({
            hideHandler: true
          });
        }, _this.props.timeout);
      }
    };

    _this.handlerContainerScroll = function () {
      _this.resetHandlerHider();

      var el = _this.el;
      var top = el.scrollTop / (el.scrollHeight - _this.offsetHeight) * (1 - _this.offsetHeight / _this.lastScrollHeight) * 100;
      var bottom = (1 - (el.scrollTop + _this.offsetHeight) / (el.scrollHeight - _this.offsetHeight) * (1 - _this.offsetHeight / _this.lastScrollHeight)) * 100;
      if (bottom < 0) bottom = 0;
      var left = el.scrollLeft / (el.scrollWidth - _this.offsetWidth) * (1 - _this.offsetWidth / _this.lastScrollWidth) * 100;
      var right = (1 - (el.scrollLeft + _this.offsetWidth) / (el.scrollWidth - _this.offsetWidth) * (1 - _this.offsetWidth / _this.lastScrollWidth)) * 100;
      if (right < 0) right = 0;
      var pos = {
        top: top,
        bottom: bottom,
        left: left,
        right: right
      };

      if (_this.props.onScrollbarScroll) {
        _this.props.onScrollbarScroll(_this.el);
      }

      _this.setState({
        handlerPos: pos
      }, function () {
        _this.detectScrolling();
      });
    };

    _this.handleHandlerMouseDown = function (e, d) {
      _this.resetHandlerHider();

      _this.lastContainerScrollTop = _this.el.scrollTop;
      _this.lastContainerScrollLeft = _this.el.scrollLeft;
      _this.activeHandler = d;
      _this.lastMousePos = {
        top: e.clientY,
        left: e.clientX
      };

      _this.setState({
        noselect: true
      });
    };

    _this.handleHandlerMouseMove = function (event) {
      if (_this.activeHandler === Direction.Vertical) {
        var delY = event.clientY - _this.lastMousePos.top;
        _this.el.scrollTop = _this.lastContainerScrollTop + delY / _this.offsetHeight * _this.lastScrollHeight;
      }

      if (_this.activeHandler === Direction.Horizontal) {
        console.log(_this.activeHandler);
        var delX = event.clientX - _this.lastMousePos.left;
        _this.el.scrollLeft = _this.lastContainerScrollLeft + delX / _this.offsetWidth * _this.lastScrollWidth;
      }
    };

    _this.handleHandlerMouseUp = function () {
      _this.lastMousePos = null;
      _this.activeHandler = null;

      _this.setState({
        noselect: false
      });
    };

    _this.setPosition = function (pos) {
      if (pos.top) {
        _this.el.scrollTop = pos.top;
      }

      if (pos.left) {
        _this.el.scrollLeft = pos.left;
      }
    };

    _this.getScrolling = function () {
      return _this.scrolling;
    };

    _this.state = {
      showVeriticalTrack: false,
      showHorizontalTrack: false,
      noselect: false,
      scrollbarWidth: 0,
      handlerPos: {
        // Vertical handler.
        top: 0,
        bottom: 0,
        // Horizontal handler.
        left: 0,
        right: 0
      },
      hideHandler: props.autoHide
    };
    return _this;
  }

  _createClass(Scrollbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.prepareScrollbar);
      document.addEventListener('mousemove', this.handleHandlerMouseMove);
      document.addEventListener('mouseup', this.handleHandlerMouseUp);
      document.addEventListener('readystatechange', this.handleReadyStateChange);
      this.prepareScrollbar();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.prepareScrollbar);
      document.removeEventListener('mousemove', this.handleHandlerMouseMove);
      document.removeEventListener('mouseup', this.handleHandlerMouseUp);
      document.removeEventListener('readystatechange', this.handleReadyStateChange);
      clearTimeout(this.handlerHider);
      clearInterval(this.detectScrollingInterval);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _prevProps$showData, _prevProps$showData$l, _this$props$showData, _this$props$showData$;

      if (!_.isEqual(prevProps.dataSource, this.props.dataSource) || ((_prevProps$showData = prevProps.showData) === null || _prevProps$showData === void 0 ? void 0 : (_prevProps$showData$l = _prevProps$showData.list) === null || _prevProps$showData$l === void 0 ? void 0 : _prevProps$showData$l.length) !== ((_this$props$showData = this.props.showData) === null || _this$props$showData === void 0 ? void 0 : (_this$props$showData$ = _this$props$showData.list) === null || _this$props$showData$ === void 0 ? void 0 : _this$props$showData$.length)) {
        this.updateTrackVisibilities(); // Trigger auto hider.

        this.handlerContainerScroll();
      }
    }
  }, {
    key: "handleScrollStart",
    value: function handleScrollStart() {
      var onScrollbarStart = this.props.onScrollbarStart;
      if (onScrollbarStart) onScrollbarStart();
    }
  }, {
    key: "handleScrollStop",
    value: function handleScrollStop() {
      var onScrollbarStop = this.props.onScrollbarStop;
      if (onScrollbarStop) onScrollbarStop();
    }
  }, {
    key: "detectScrolling",
    value: function detectScrolling() {
      var _this2 = this;

      if (this.scrolling) return;
      this.scrolling = true;
      this.handleScrollStart();
      this.detectScrollingInterval = setInterval(function () {
        if (_this2.lastViewScrollLeft === _this2.state.handlerPos.left && _this2.lastViewScrollTop === _this2.state.handlerPos.top) {
          clearInterval(_this2.detectScrollingInterval);
          _this2.scrolling = false;

          _this2.handleScrollStop();
        }

        _this2.lastViewScrollLeft = _this2.state.handlerPos.left;
        _this2.lastViewScrollTop = _this2.state.handlerPos.top;
      }, 100);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          scrollbarWidth = _this$state.scrollbarWidth,
          noselect = _this$state.noselect; // Dynamic styles

      var containerStyles = {
        marginRight: scrollbarWidth ? -scrollbarWidth : 0,
        marginBottom: scrollbarWidth ? -scrollbarWidth : 0,
        right: "-".concat(this.props.browserOffset),
        bottom: 0,
        paddingRight: this.props.browserOffset,
        paddingBottom: 0
      };

      if (noselect) {
        containerStyles.userSelect = 'none';
        containerStyles.MozUserSelect = 'none';
        containerStyles.WebkitUserSelect = 'none';
        containerStyles.msUserSelect = 'none';
      }

      var verticalTrackStyles = {
        top: this.props.fixedOffset.top,
        bottom: this.state.showHorizontalTrack ? this.props.trackSize : '0',
        opacity: this.state.hideHandler ? 0 : 1
      };
      var horizontalTrackStyles = {
        left: this.props.fixedOffset.left || 0,
        right: this.state.showVeriticalTrack ? this.props.trackSize : '0',
        opacity: 1
      }; // TODO: resolve the bottom issue and the horizontal handler length.
      // TODO: convert this into the config option.

      var min = 5;
      var verticalHandlerHeight = Math.max(100 - this.state.handlerPos.bottom - this.state.handlerPos.top, min);
      var verticalHandlerStyles = {
        top: this.state.handlerPos.top + '%',
        bottom: 100 - verticalHandlerHeight - this.state.handlerPos.top + '%',
        opacity: this.state.hideHandler ? 0 : 1
      };
      var horizontalHandlerStyles = {
        left: this.state.handlerPos.left + '%',
        right: this.state.handlerPos.right + '%',
        opacity: 1
      };
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: "scrollbar ".concat(this.props.className),
        style: _objectSpread(_objectSpread({}, this.props.style), styles.main)
      }, /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-container",
        style: _objectSpread(_objectSpread({}, containerStyles), styles.container),
        ref: function ref(container) {
          return _this3.el = container;
        },
        onScroll: this.handlerContainerScroll
      }, this.props.children)), this.state.showVeriticalTrack ? /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-vertical-track",
        style: this.props.className ? Object.assign(verticalTrackStyles, styles.track.vertical) : Object.assign(verticalTrackStyles, styles.track.vertical, styles.track.verticalCustomize)
      }, /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-vertical-handler",
        onMouseDown: function onMouseDown(event) {
          _this3.handleHandlerMouseDown(event, Direction.Vertical);
        },
        style: this.props.className ? Object.assign(verticalHandlerStyles, styles.handler.vertical) : Object.assign(verticalHandlerStyles, styles.handler.vertical, styles.handler.verticalCustomize)
      })) : null, this.state.showHorizontalTrack ? /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-horizontal-track",
        style: this.props.className ? Object.assign(horizontalTrackStyles, styles.track.horizontal) : Object.assign(horizontalTrackStyles, styles.track.horizontal, styles.track.horizontalCustomize)
      }, /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-horizontal-handler",
        onMouseDown: function onMouseDown(event) {
          _this3.handleHandlerMouseDown(event, Direction.Horizontal);
        },
        style: this.props.className ? Object.assign(horizontalHandlerStyles, styles.handler.horizontal) : Object.assign(horizontalHandlerStyles, styles.handler.horizontal, styles.handler.horizontalCustomize)
      })) : null, this.state.showHorizontalTrack && this.state.showVeriticalTrack && !this.props.fixed ? /*#__PURE__*/React.createElement("div", {
        className: "scrollbar-square",
        style: styles.square
      }) : null);
    }
  }]);

  return Scrollbar;
}(React.PureComponent);

Scrollbar.displayName = 'Scrollbar';
Scrollbar.defaultProps = {
  className: '',
  style: {
    width: '100%',
    height: '100%'
  },
  fixed: false,
  autoHide: false,
  timeout: 2000,
  trackSize: '10px',
  start: '',
  browserOffset: '17px',
  onScrollbarScroll: null,
  onScrollbarScrollTimeout: 300
};
export { Scrollbar as default };