/// <reference types="react" />
import type { Key, DataIndex, ColumnsType, CellType } from '../types';
export declare function getPathValue<ValueType, ObjectType extends object>(record: ObjectType, path: DataIndex): ValueType | null;
interface GetColumnKeyColumn {
    key?: Key;
    dataIndex?: DataIndex;
}
export declare function getColumnsKey(columns: readonly GetColumnKeyColumn[]): import("react").Key[];
export declare function parseHeaderRows<RecordType>(rootColumns: ColumnsType<RecordType>): CellType<RecordType>[][];
export declare function parseFooterRows<RecordType>(rootColumns: ColumnsType<RecordType>, data?: any): CellType<RecordType>[][];
export declare function getNumCellWidth(colStart: number, colSpan: number, colWidths: readonly (number | string)[]): string | number;
export declare function getCellWidth(colStart: number, colSpan: number, colWidths: readonly (number | string)[]): string | 0;
export declare function validateValue<T>(val: T): boolean;
export {};
