import React, { useEffect, useRef } from 'react';
import "./index.css";

function TheInput(_ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      config = _ref.config;
  var divEl = useRef(null);

  var divOnFocus = function divOnFocus() {
    var _divEl$current;

    (_divEl$current = divEl.current) === null || _divEl$current === void 0 ? void 0 : _divEl$current.focus();
    var range = document.createRange();
    range.selectNodeContents(divEl.current);
    range.collapse(false);
    var selection = window.getSelection();
    selection === null || selection === void 0 ? void 0 : selection.removeAllRanges();
    selection === null || selection === void 0 ? void 0 : selection.addRange(range);
  };

  useEffect(function () {
    divOnFocus();
  }, []);
  useEffect(function () {
    if (config.isFocusing === false) {
      onChange(divEl.current.innerText);
    }

    console.log('input focus change', config.isFocusing);
  }, [config.isFocusing]);
  return /*#__PURE__*/React.createElement("div", {
    suppressContentEditableWarning: true,
    contentEditable: true,
    ref: divEl,
    className: "div-input"
  }, value);
}

export default TheInput;