"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sizeMap = exports.default = exports.ArtTableAction = void 0;

require("antd/es/spin/style");

var _spin = _interopRequireDefault(require("antd/es/spin"));

require("antd/es/config-provider/style");

var _configProvider = _interopRequireDefault(require("antd/es/config-provider"));

require("antd/es/pagination/style");

var _pagination = _interopRequireDefault(require("antd/es/pagination"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _omit = _interopRequireDefault(require("rc-util/lib/omit"));

var _immer = _interopRequireDefault(require("immer"));

var _zh_CN = _interopRequireDefault(require("antd/es/locale/zh_CN"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactRedux = require("react-redux");

var _ahooks = require("ahooks");

var _ExperimentTable = require("../ExperimentTable");

var _usePagination3 = _interopRequireWildcard(require("./hooks/usePagination"));

var _useSelection3 = _interopRequireDefault(require("./hooks/useSelection"));

var _useLazyKVMap3 = _interopRequireDefault(require("./hooks/useLazyKVMap"));

var _useTitleColumns3 = _interopRequireDefault(require("./hooks/useTitleColumns"));

var _index2 = _interopRequireDefault(require("./hooks/useFilter/index"));

var _useTable = _interopRequireDefault(require("./hooks/useTable"));

var _Toolbar = _interopRequireDefault(require("./Toolbar"));

require("../assets/icomoon/style.css");

require("./style/index.css");

var _ArtTableContext = require("./core/ArtTableContext");

var _ArtTableHelpContext = require("./core/ArtTableHelpContext");

var _ArtTableEditableCellContext = require("./core/ArtTableEditableCellContext");

var _utils = require("./utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var EMPTY_LIST = [];
var ArtTableAction;
exports.ArtTableAction = ArtTableAction;

(function (ArtTableAction) {
  ArtTableAction["pagination"] = "pagination";
  ArtTableAction["filter"] = "filter";
  ArtTableAction["sort"] = "sort";
  ArtTableAction["fieldConfig"] = "fieldConfig";
  ArtTableAction["lineHeight"] = "lineHeight";
  ArtTableAction["globalShow"] = "globalShow";
  ArtTableAction["column"] = "column";
  ArtTableAction["tableScroll"] = "tableScroll";
})(ArtTableAction || (exports.ArtTableAction = ArtTableAction = {}));

var sizeMap = new Map([['large', 120], ['middle', 64], ['small', 32]]);
exports.sizeMap = sizeMap;

function ArtTable(props) {
  var _classNames2;

  var dataSource = props.dataSource,
      columns = props.columns,
      loading = props.loading,
      pagination = props.pagination,
      scroll = props.scroll,
      onChange = props.onChange,
      rowSelection = props.rowSelection,
      rowKey = props.rowKey,
      toolbarSlots = props.toolbarSlots,
      emptyText = props.emptyText,
      manager = props.manager,
      cellExtraRender = props.cellExtraRender,
      _props$checkedColumnL = props.checkedColumnLengthLowerLimit,
      checkedColumnLengthLowerLimit = _props$checkedColumnL === void 0 ? 6 : _props$checkedColumnL,
      _props$fixedColumnLen = props.fixedColumnLengthUpperLimit,
      fixedColumnLengthUpperLimit = _props$fixedColumnLen === void 0 ? 4 : _props$fixedColumnLen,
      _props$sortRulesLengt = props.sortRulesLengthUpperLimit,
      sortRulesLengthUpperLimit = _props$sortRulesLengt === void 0 ? 10 : _props$sortRulesLengt;

  var _useSelector = (0, _reactRedux.useSelector)(function (state) {
    return {
      columnConfig: state.columnConfig.byId,
      size: state.size,
      isGlobalShow: state.isGlobalShow
    };
  }),
      columnConfig = _useSelector.columnConfig,
      size = _useSelector.size,
      isGlobalShow = _useSelector.isGlobalShow;

  var childrenColumnName = 'children';
  var tableProps = (0, _omit.default)(props, ['className', 'style', 'columns']);
  var prefixCls = 'kodo-art-table';
  var rawData = dataSource || EMPTY_LIST;
  var mergedData = rawData.slice();
  var internalRefs = {
    body: _react.default.useRef(),
    container: _react.default.useRef(),
    bodyInner: _react.default.useRef()
  }; // ============================ RowKey ============================

  var getRowKey = _react.default.useMemo(function () {
    if (typeof rowKey === 'function') {
      return rowKey;
    }

    return function (record) {
      return record === null || record === void 0 ? void 0 : record[rowKey];
    };
  }, [rowKey]);

  var _useLazyKVMap = (0, _useLazyKVMap3.default)(rawData, childrenColumnName, getRowKey),
      _useLazyKVMap2 = _slicedToArray(_useLazyKVMap, 1),
      getRecordByKey = _useLazyKVMap2[0]; // ============================ Events =============================


  var changeEventInfo = {};

  var triggerOnChange = function triggerOnChange(info, action) {
    var reset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    var changeInfo = _objectSpread(_objectSpread({}, changeEventInfo), info);

    if (reset) {
      changeEventInfo.resetPagination(); // Reset event param

      if (changeInfo.pagination.current) {
        changeInfo.pagination.current = 1;
      } // Trigger pagination events


      if (pagination && pagination.onChange) {
        pagination.onChange(1, changeInfo.pagination.pageSize);
      }
    }

    if (scroll && scroll.scrollToFirstRowOnChange !== false && internalRefs.body.current) {
      var _internalRefs$body$cu;

      (_internalRefs$body$cu = internalRefs.body.current) === null || _internalRefs$body$cu === void 0 ? void 0 : _internalRefs$body$cu.setPosition({
        top: 0
      });
    }

    onChange === null || onChange === void 0 ? void 0 : onChange(info, manager.getState(), action);
  }; // >>>>>>>>> filter


  var onFilterChange = function onFilterChange(filter) {
    triggerOnChange({
      filter: filter
    }, 'filter');
  };

  var _useFilter = (0, _index2.default)({
    prefixCls: prefixCls,
    mergedColumns: columns,
    onFilterChange: onFilterChange
  }),
      _useFilter2 = _slicedToArray(_useFilter, 1),
      transformFilterColumns = _useFilter2[0]; // >>>>>>>>> column


  var onColumnChange = function onColumnChange(column) {
    triggerOnChange({
      column: column
    }, 'column');
  };

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isTableColumnResize = _useState2[0],
      setIsTableColumnResize = _useState2[1];

  var _useTitleColumns = (0, _useTitleColumns3.default)(manager, {
    onColumnChange: onColumnChange
  }),
      _useTitleColumns2 = _slicedToArray(_useTitleColumns, 1),
      transformTitleColumns = _useTitleColumns2[0]; // >>>>>>>>> pagination


  var onPaginationChange = function onPaginationChange(current, pageSize) {
    // manager.getActions().updatePagination({ pageSize });
    triggerOnChange({
      pagination: _objectSpread(_objectSpread({}, changeEventInfo.pagination), {}, {
        current: current,
        pageSize: pageSize
      })
    }, 'pagination');
  };

  var _usePagination = (0, _usePagination3.default)(rawData.length, pagination, onPaginationChange),
      _usePagination2 = _slicedToArray(_usePagination, 2),
      mergedPagination = _usePagination2[0],
      resetPagination = _usePagination2[1];

  changeEventInfo.pagination = pagination === false ? {} : (0, _usePagination3.getPaginationParam)(pagination, mergedPagination);
  changeEventInfo.resetPagination = resetPagination;
  var bottomPaginationNode;

  if (pagination !== false && (mergedPagination === null || mergedPagination === void 0 ? void 0 : mergedPagination.total)) {
    var renderPagination = function renderPagination(position) {
      return /*#__PURE__*/_react.default.createElement(_pagination.default, _objectSpread(_objectSpread({
        className: "".concat(prefixCls, "-pagination ").concat(prefixCls, "-pagination-").concat(position),
        showSizeChanger: true,
        showQuickJumper: true
      }, mergedPagination), {}, {
        size: 'default'
      }));
    };

    bottomPaginationNode = renderPagination('right');
  } // >>>>>>>>> Spinning


  var spinProps;

  if (typeof loading === 'boolean') {
    spinProps = {
      spinning: loading
    };
  } else if (_typeof(loading) === 'object') {
    spinProps = _objectSpread({
      spinning: true
    }, loading);
  } // ============================= Data =============================


  var pageData = _react.default.useMemo(function () {
    if (isGlobalShow || pagination === false || !mergedPagination.pageSize) {
      return mergedData;
    }

    var _mergedPagination$cur = mergedPagination.current,
        current = _mergedPagination$cur === void 0 ? 1 : _mergedPagination$cur,
        total = mergedPagination.total,
        _mergedPagination$pag = mergedPagination.pageSize,
        pageSize = _mergedPagination$pag === void 0 ? _usePagination3.DEFAULT_PAGE_SIZE : _mergedPagination$pag; // Dynamic table data

    if (mergedData.length < total) {
      if (mergedData.length > pageSize) {
        return mergedData.slice((current - 1) * pageSize, current * pageSize);
      }

      return mergedData;
    }

    return mergedData.slice((current - 1) * pageSize, current * pageSize);
  }, [!!pagination, mergedData, isGlobalShow, mergedPagination && mergedPagination.current, mergedPagination && mergedPagination.pageSize, mergedPagination && mergedPagination.total]); // ========================== Selections ==========================


  var _useSelection = (0, _useSelection3.default)(rowSelection, {
    prefixCls: prefixCls,
    data: mergedData,
    pageData: pageData,
    getRowKey: getRowKey,
    getRecordByKey: getRecordByKey,
    childrenColumnName: childrenColumnName
  }),
      _useSelection2 = _slicedToArray(_useSelection, 2),
      transformSelectionColumns = _useSelection2[0],
      selectedKeySet = _useSelection2[1]; // ============================ Render ============================


  var transformColumns = _react.default.useCallback(function (innerColumns) {
    return transformTitleColumns(transformSelectionColumns(transformFilterColumns(innerColumns)));
  }, [transformFilterColumns, transformSelectionColumns]);

  var internalRowClassName = function internalRowClassName(record, index) {
    return (0, _classnames.default)(_defineProperty({}, "".concat(prefixCls, "-row-selected"), selectedKeySet.has(getRowKey(record, index))));
  };

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      init = _useState4[0],
      setInit = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isTableScroll = _useState6[0],
      setIsTableScroll = _useState6[1];

  var _useState7 = (0, _react.useState)({
    rowIndex: null,
    columnIndex: null
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      selectedCell = _useState8[0],
      setSelectedCell = _useState8[1];

  (0, _react.useEffect)(function () {
    // 还需要提供trigger事件,提示用户
    setInit(true);
    var newColumns = (0, _utils.computedColumn)(columnConfig, columns);

    if ((columnConfig === null || columnConfig === void 0 ? void 0 : columnConfig.length) >= 0) {
      var _state = (0, _utils.formatTableStoreInInImmutable)(newColumns);

      manager.getActions().updateColumnConfig(_state);
    }

    triggerOnChange({
      type: 'init'
    }, 'fieldConfig');
  }, []);
  (0, _ahooks.useClickAway)(function () {
    setSelectedCell({
      rowIndex: null,
      columnIndex: null
    });
  }, internalRefs.bodyInner);

  if (!init) {
    return null;
  }

  _configProvider.default.config({
    theme: {
      primaryColor: '#02b890'
    }
  });

  return /*#__PURE__*/_react.default.createElement(_configProvider.default, {
    locale: _zh_CN.default
  }, /*#__PURE__*/_react.default.createElement(_ArtTableContext.ArtTableContext.Provider, {
    value: {
      manager: manager
    }
  }, /*#__PURE__*/_react.default.createElement(_ArtTableHelpContext.ArtTableHelpContext.Provider, {
    value: {
      checkedColumnLengthLowerLimit: checkedColumnLengthLowerLimit,
      fixedColumnLengthUpperLimit: fixedColumnLengthUpperLimit,
      sortRulesLengthUpperLimit: sortRulesLengthUpperLimit,
      isTableScroll: isTableScroll,
      isTableColumnResize: isTableColumnResize,
      triggerOnChange: triggerOnChange,
      columns: columns
    }
  }, /*#__PURE__*/_react.default.createElement(_ArtTableEditableCellContext.ArtTableEditableCellContext.Provider, {
    value: {
      size: size,
      selectedCell: selectedCell
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-wrapper")
  }, /*#__PURE__*/_react.default.createElement(_Toolbar.default, {
    prefixCls: prefixCls,
    slots: toolbarSlots
  }), /*#__PURE__*/_react.default.createElement(_spin.default, _objectSpread({
    wrapperClassName: "".concat(prefixCls, "-loading"),
    spinning: false
  }, spinProps), /*#__PURE__*/_react.default.createElement(_ExperimentTable.ExperimentTable, _objectSpread(_objectSpread({}, tableProps), {}, {
    prefixCls: prefixCls,
    className: (0, _classnames.default)((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-large"), size === 'large'), _defineProperty(_classNames2, "".concat(prefixCls, "-middle"), size === 'middle'), _defineProperty(_classNames2, "".concat(prefixCls, "-small"), size === 'small'), _defineProperty(_classNames2, "".concat(prefixCls, "-empty"), size === 0), _classNames2)),
    cellExtraRender: cellExtraRender,
    getExtraState: function getExtraState() {
      return _objectSpread(_objectSpread({}, manager.getState()), {}, {
        selectedCell: selectedCell
      });
    },
    rowClassName: internalRowClassName,
    itemHeight: sizeMap.get(size),
    summaryHeight: 33,
    data: pageData,
    columns: (0, _utils.computedColumn)(columnConfig, columns, true),
    internalRefs: internalRefs,
    onScrollbarStart: function onScrollbarStart() {
      setIsTableScroll(true);
      triggerOnChange({
        isScroll: true
      }, 'tableScroll');
    },
    onScrollbarStop: function onScrollbarStop() {
      setIsTableScroll(false);
      triggerOnChange({
        isScroll: false
      }, 'tableScroll');
    },
    onColumnResizeStart: function onColumnResizeStart() {
      setIsTableColumnResize(true);
    },
    onColumnResizeStop: function onColumnResizeStop(width, uniqueId) {
      var _manager$getState$col, _manager$getState$col2;

      setIsTableColumnResize(false);

      var _ColumnConfig = (0, _immer.default)(manager.getState().columnConfig.byId, function (draft) {
        var _index = draft.findIndex(function (s) {
          return s.dataIndex === uniqueId;
        });

        if (_index !== -1) {
          draft[_index].width = width < (draft[_index].minWidth || 96) ? draft[_index].minWidth || 96 : width;
        }
      });

      manager.getActions().updateColumnConfig(_ColumnConfig);
      triggerOnChange({
        column: (_manager$getState$col = manager.getState().columnConfig) === null || _manager$getState$col === void 0 ? void 0 : (_manager$getState$col2 = _manager$getState$col.byId) === null || _manager$getState$col2 === void 0 ? void 0 : _manager$getState$col2.find(function (c) {
          return c.dataIndex === uniqueId;
        })
      }, 'column');
    },
    selectedColor: '#EBF5FF',
    transformColumns: transformColumns,
    emptyText: emptyText,
    onCell: function onCell(_, rowIndex, colIndex) {
      return {
        onClick: function onClick() {
          setSelectedCell({
            rowIndex: rowIndex,
            columnIndex: colIndex
          });
        }
      };
    },
    onHeaderCell: function onHeaderCell(_, rowIndex, colIndex) {
      return {
        onClick: function onClick() {
          setTimeout(function () {
            setSelectedCell({
              rowIndex: rowIndex,
              columnIndex: colIndex
            });
          });
        }
      };
    },
    onSummaryRow: function onSummaryRow() {
      return {
        onClick: function onClick() {
          setSelectedCell({
            rowIndex: null,
            columnIndex: null
          });
        }
      };
    }
  }))), !isGlobalShow && bottomPaginationNode)))));
}

ArtTable.defaultProps = {
  rowKey: 'key',
  size: 'middle',
  summaryHeight: 33,
  checkedColumnLengthLowerLimit: 6,
  fixedColumnLengthUpperLimit: 4,
  sortRulesLengthUpperLimit: 10
};

var _default = function _default(props) {
  var size = props.size,
      columns = props.columns,
      tableInstance = props.tableInstance;
  var manager = tableInstance;

  if (_lodash.default.isUndefined(tableInstance)) {
    manager = (0, _useTable.default)({
      size: size,
      columns: (0, _utils.formatTableStoreInInImmutable)(columns)
    });
  }

  return /*#__PURE__*/_react.default.createElement(_reactRedux.Provider, {
    store: manager.getStore()
  }, /*#__PURE__*/_react.default.createElement(ArtTable, _objectSpread(_objectSpread({}, props), {}, {
    manager: manager
  })));
};

exports.default = _default;