"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FieldItem = void 0;

require("antd/es/message/style");

var _message2 = _interopRequireDefault(require("antd/es/message"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactSortableHoc = require("react-sortable-hoc");

var _immer = _interopRequireDefault(require("immer"));

var _lodash = _interopRequireDefault(require("lodash"));

var _ArtTableContext = require("../../core/ArtTableContext");

var _ArtTableHelpContext = require("../../core/ArtTableHelpContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DragHandle = (0, _reactSortableHoc.SortableHandle)(function (_ref) {
  var isDrag = _ref.isDrag,
      isFixed = _ref.isFixed,
      prefixCls = _ref.prefixCls;
  return /*#__PURE__*/_react.default.createElement("i", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item-drag-icon"), "icon-tuodong"),
    style: {
      fontSize: 28,
      marginRight: 2,
      color: isDrag ? '#02B980' : isFixed ? '#BBBBBB' : '#666666',
      cursor: isFixed ? 'pointer' : 'move'
    }
  });
});
var FieldItem = (0, _reactSortableHoc.SortableElement)(function (_ref2) {
  var _classNames4, _classNames5;

  var isDrag = _ref2.isDrag,
      isFixed = _ref2.isFixed,
      isHidden = _ref2.isHidden,
      prefixCls = _ref2.prefixCls,
      item = _ref2.item,
      dIndex = _ref2.dIndex;

  var _useContext = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = (0, _react.useContext)(_ArtTableHelpContext.ArtTableHelpContext),
      checkedColumnLengthLowerLimit = _useContext2.checkedColumnLengthLowerLimit,
      fixedColumnLengthUpperLimit = _useContext2.fixedColumnLengthUpperLimit,
      triggerOnChange = _useContext2.triggerOnChange;

  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-drag"), isDrag))
  }, /*#__PURE__*/_react.default.createElement(DragHandle, {
    isDrag: isDrag,
    isFixed: isFixed,
    prefixCls: prefixCls
  }), (item === null || item === void 0 ? void 0 : item.icon) && /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item-icon"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-hidden"), isHidden))
  }, item === null || item === void 0 ? void 0 : item.icon), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item-title"), _defineProperty({}, "".concat(prefixCls, "-toolbar-field-config-item-hidden"), isHidden))
  }, item === null || item === void 0 ? void 0 : item.title), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-field-config-item-right")
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item-right-icon"), "icon-guding", (_classNames4 = {}, _defineProperty(_classNames4, "".concat(prefixCls, "-toolbar-field-config-item-right-icon-fixed"), isFixed), _defineProperty(_classNames4, "".concat(prefixCls, "-toolbar-field-config-item-right-icon-fixed-hidden"), isHidden), _classNames4)),
    style: {
      marginRight: 12
    },
    onClick: function onClick() {
      if (!isHidden) {
        var _ColumnConfig = (0, _immer.default)(manager.getState().columnConfig.byId, function (draft) {
          var _draft$dIndex;

          var isUpperLimit = draft.filter(function (v) {
            return v.fixed === 'left' || v.fixed === true;
          }).length >= fixedColumnLengthUpperLimit;

          if (isUpperLimit && ((_draft$dIndex = draft[dIndex]) === null || _draft$dIndex === void 0 ? void 0 : _draft$dIndex.fixed) !== 'left') {
            _message2.default.error("\u6700\u591A\u56FA\u5B9A".concat(fixedColumnLengthUpperLimit, "\u5217!"));
          } else {
            draft[dIndex].fixed = draft[dIndex].fixed === 'left' ? '' : 'left';
            var _item = draft.splice(dIndex, 1)[0];

            var lastFixedIndex = _lodash.default.findLastIndex(draft, function (v) {
              return v.fixed === 'left';
            });

            draft.splice(lastFixedIndex === -1 ? 0 : lastFixedIndex + 1, 0, _item);
          }
        });

        manager.getActions().updateColumnConfig(_ColumnConfig);
        triggerOnChange({
          type: 'fixed',
          index: dIndex
        }, 'fieldConfig');
      }
    }
  }), /*#__PURE__*/_react.default.createElement("i", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-field-config-item-right-icon"), (_classNames5 = {}, _defineProperty(_classNames5, "icon-uniE945", !isHidden), _defineProperty(_classNames5, 'icon-yincang2', isHidden), _classNames5)),
    onClick: function onClick() {
      var _ColumnConfig = (0, _immer.default)(manager.getState().columnConfig.byId, function (draft) {
        var isUpperLimit = draft.filter(function (v) {
          return v.fixed !== 'left' && v.fixed !== 'right' && !v.hidden;
        }).length <= checkedColumnLengthLowerLimit;

        if (isUpperLimit && !isFixed && !isHidden) {
          _message2.default.error("\u975E\u56FA\u5B9A\u5217\u6570\u91CF\u4E0D\u80FD\u5C11\u4E8E".concat(checkedColumnLengthLowerLimit, "\u4E2A!"));
        } else {
          draft[dIndex].hidden = !draft[dIndex].hidden;
        }
      });

      manager.getActions().updateColumnConfig(_ColumnConfig);
      triggerOnChange({
        type: 'hidden',
        index: dIndex
      }, 'fieldConfig');
    }
  })));
});
exports.FieldItem = FieldItem;