"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FieldList = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSortableHoc = require("react-sortable-hoc");

var _FieldItem = require("./FieldItem");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldList = (0, _reactSortableHoc.SortableContainer)(function (_ref) {
  var prefixCls = _ref.prefixCls,
      items = _ref.items,
      dragIndex = _ref.dragIndex;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-field-config-list")
  }, items.filter(function (item) {
    return item.hiddenColumnConfig !== true;
  }).map(function (v, i) {
    var isDrag = dragIndex === i;
    var isFixed = (v === null || v === void 0 ? void 0 : v.fixed) === 'left';
    var isHidden = (v === null || v === void 0 ? void 0 : v.hidden) === true;
    return /*#__PURE__*/_react.default.createElement(_FieldItem.FieldItem, {
      isDrag: isDrag,
      isFixed: isFixed,
      isHidden: isHidden,
      key: v === null || v === void 0 ? void 0 : v.dataIndex,
      index: i,
      dIndex: i,
      prefixCls: prefixCls,
      collection: isFixed ? -1 : 0,
      disabled: isFixed,
      item: v
    });
  }));
});
exports.FieldList = FieldList;