"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ZFButton = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _immer = _interopRequireDefault(require("immer"));

var _ArtTableContext = require("../../../core/ArtTableContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ZFButton = function ZFButton(_ref) {
  var rulePrefixCls = _ref.rulePrefixCls,
      checked = _ref.checked,
      dIndex = _ref.dIndex,
      triggerOnChange = _ref.triggerOnChange;

  var _useContext = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext.manager;

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(rulePrefixCls, "-zf-button")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(rulePrefixCls, "-button-left"), _defineProperty({}, "".concat(rulePrefixCls, "-button-checked"), !checked)),
    onClick: function onClick() {
      var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
        draft[dIndex].rule = 'asc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'trigger',
        rule: 'asc',
        order: dIndex
      }, 'sort', true);
    }
  }, "\u6B63\u5411\u6392\u5E8F"), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(rulePrefixCls, "-button-right"), _defineProperty({}, "".concat(rulePrefixCls, "-button-checked"), checked)),
    onClick: function onClick() {
      var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
        draft[dIndex].rule = 'desc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'trigger',
        rule: 'asc',
        order: dIndex
      }, 'sort', true);
    }
  }, "\u5012\u5411\u6392\u5E8F"));
};

exports.ZFButton = ZFButton;