"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortRuleItem = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactSortableHoc = require("react-sortable-hoc");

var _reactRedux = require("react-redux");

var _ArtTableContext = require("../../core/ArtTableContext");

var _ArtTableHelpContext = require("../../core/ArtTableHelpContext");

var _RuleSwitchHandle = require("./RuleButton/RuleSwitchHandle");

var _AZButton = require("./RuleButton/AZButton");

var _NumButton = require("./RuleButton/NumButton");

var _ZFButton = require("./RuleButton/ZFButton");

var _SortSelect = require("./SortSelect");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DragHandle = (0, _reactSortableHoc.SortableHandle)(function (_ref) {
  var isDrag = _ref.isDrag,
      prefixCls = _ref.prefixCls;
  return /*#__PURE__*/_react.default.createElement("i", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-drag"), "icon-tuodong"),
    style: {
      fontSize: 28,
      marginRight: 6,
      color: isDrag ? '#02B980' : '#666666',
      cursor: 'move'
    }
  });
});
var SortRuleItem = (0, _reactSortableHoc.SortableElement)(function (_ref2) {
  var isDrag = _ref2.isDrag,
      prefixCls = _ref2.prefixCls,
      item = _ref2.item,
      dIndex = _ref2.dIndex;

  var _useContext = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = (0, _react.useContext)(_ArtTableHelpContext.ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  var sortSelectList = (0, _reactRedux.useSelector)(function (state) {
    return state.columnConfig.byId.filter(function (c) {
      return !_lodash.default.isUndefined(c.sort) && c.sort !== false;
    }).map(function (c) {
      return _objectSpread(_objectSpread({}, c), {}, {
        disabled: !!state.sorts.find(function (s) {
          return s.key === c.dataIndex;
        }),
        title: (c === null || c === void 0 ? void 0 : c.textTitle) || (c === null || c === void 0 ? void 0 : c.title)
      });
    });
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-item"), _defineProperty({}, "".concat(prefixCls, "-toolbar-sort-item-drag"), isDrag))
  }, /*#__PURE__*/_react.default.createElement(DragHandle, {
    isDrag: isDrag,
    prefixCls: prefixCls
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-select"))
  }, (item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-select-default"))
  }, item.title), !(item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/_react.default.createElement(_SortSelect.SortSelect, {
    data: sortSelectList,
    item: item,
    dIndex: dIndex,
    prefixCls: prefixCls,
    triggerOnChange: triggerOnChange
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-rule"))
  }, item.type === 'az' && /*#__PURE__*/_react.default.createElement(_AZButton.AZButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), item.type === '09' && /*#__PURE__*/_react.default.createElement(_NumButton.NumButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), item.type === 'zf' && /*#__PURE__*/_react.default.createElement(_ZFButton.ZFButton, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    dIndex: dIndex,
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule"),
    triggerOnChange: triggerOnChange
  }), /*#__PURE__*/_react.default.createElement(_RuleSwitchHandle.RuleSwitchHandle, {
    checked: (item === null || item === void 0 ? void 0 : item.rule) === 'desc',
    rulePrefixCls: "".concat(prefixCls, "-toolbar-sort-rule")
  })), !(item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/_react.default.createElement("i", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-delete"), "icon-shanchu4"),
    onClick: function onClick() {
      manager.getActions().removeSort({
        order: dIndex
      });
      triggerOnChange({
        type: 'remove',
        order: dIndex
      }, 'sort', true);
    }
  }), (item === null || item === void 0 ? void 0 : item.isDefault) && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginLeft: '4px',
      width: '24px',
      height: '24px'
    }
  }));
});
exports.SortRuleItem = SortRuleItem;