"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortRuleList = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactSortableHoc = require("react-sortable-hoc");

var _SortRuleItem = require("./SortRuleItem");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SortRuleList = (0, _reactSortableHoc.SortableContainer)(function (_ref) {
  var prefixCls = _ref.prefixCls,
      items = _ref.items,
      dragIndex = _ref.dragIndex;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-sort-list")
  }, items.filter(function (item) {
    return item.hiddenColumnConfig !== true;
  }).map(function (v, i) {
    var isDrag = dragIndex === i;
    return /*#__PURE__*/_react.default.createElement(_SortRuleItem.SortRuleItem, {
      isDrag: isDrag,
      key: v === null || v === void 0 ? void 0 : v.dataIndex,
      index: i,
      dIndex: i,
      prefixCls: prefixCls,
      item: v
    });
  }));
});
exports.SortRuleList = SortRuleList;