"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortSelect = void 0;

require("antd/es/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/es/dropdown"));

require("antd/es/menu/style");

var _menu = _interopRequireDefault(require("antd/es/menu"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _immer = _interopRequireDefault(require("immer"));

var _ArtTableContext = require("../../core/ArtTableContext");

var _ArtTableHelpContext = require("../../core/ArtTableHelpContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var SortSelect = function SortSelect(_ref) {
  var prefixCls = _ref.prefixCls,
      item = _ref.item,
      data = _ref.data,
      dIndex = _ref.dIndex;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useContext = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = (0, _react.useContext)(_ArtTableHelpContext.ArtTableHelpContext),
      triggerOnChange = _useContext2.triggerOnChange;

  var menu = /*#__PURE__*/_react.default.createElement(_menu.default, {
    selectedKeys: [item.key],
    onClick: function onClick(_ref2) {
      var key = _ref2.key;

      var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
        var _curr$sort;

        var curr = data.find(function (c) {
          return c.dataIndex === key;
        });
        draft[dIndex].key = key;
        draft[dIndex].title = (curr === null || curr === void 0 ? void 0 : curr.textTitle) || (curr === null || curr === void 0 ? void 0 : curr.title);
        draft[dIndex].type = ((_curr$sort = curr.sort) === null || _curr$sort === void 0 ? void 0 : _curr$sort.type) || 'zf';
        draft[dIndex].rule = 'desc';
      });

      manager.getActions().updateSort(_sorts);
      triggerOnChange({
        type: 'change',
        index: dIndex
      }, 'sort', true);
    },
    items: data === null || data === void 0 ? void 0 : data.map(function (v) {
      return {
        label: v.title,
        disabled: v === null || v === void 0 ? void 0 : v.disabled,
        key: v.dataIndex
      };
    })
  });

  return /*#__PURE__*/_react.default.createElement(_dropdown.default, {
    overlay: menu,
    trigger: ['click'],
    overlayClassName: "".concat(prefixCls, "-toolbar-sort-select-item-dropdown"),
    onVisibleChange: function onVisibleChange(v) {
      setVisible(v);
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-select-item"))
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-select-item-title"))
  }, item.title), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-sort-select-item-icon"))
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: visible ? 'icon-shangla' : 'icon-xiala',
    style: {
      fontSize: 24
    }
  }))));
};

exports.SortSelect = SortSelect;