"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/space/style");

var _space = _interopRequireDefault(require("antd/es/space"));

require("antd/es/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/es/dropdown"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _arrayMove = require("array-move");

var _reactRedux = require("react-redux");

var _immer = _interopRequireDefault(require("immer"));

var _ArtTableContext = require("../../core/ArtTableContext");

var _ArtTableHelpContext = require("../../core/ArtTableHelpContext");

var _SortRuleList = require("./SortRuleList");

var _SortRuleCreateButton = require("./SortRuleCreateButton");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * 获取列配置中的第一个可配置的元素作为sort的默认元素
 * 该元素不能是默认元素
 * 且需要排除已创建的条件
 * @param byId
 * @param sorts
 */
function getFirstItem(byId, sorts) {
  return byId.find(function (config) {
    return !_lodash.default.isUndefined(config.sort) && config.sort !== false && (config === null || config === void 0 ? void 0 : config.sort.isDefault) !== true && sorts.filter(function (s) {
      return s.key === config.dataIndex;
    }).length === 0;
  });
}

var Sort = function Sort(_ref) {
  var prefixCls = _ref.prefixCls;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useState3 = (0, _react.useState)(-1),
      _useState4 = _slicedToArray(_useState3, 2),
      dragIndex = _useState4[0],
      setDragIndex = _useState4[1];

  var _useContext = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext.manager;

  var _useContext2 = (0, _react.useContext)(_ArtTableHelpContext.ArtTableHelpContext),
      sortRulesLengthUpperLimit = _useContext2.sortRulesLengthUpperLimit,
      triggerOnChange = _useContext2.triggerOnChange;

  var sorts = (0, _reactRedux.useSelector)(function (state) {
    return state.sorts;
  });
  var firstItem = (0, _reactRedux.useSelector)(function (state) {
    return getFirstItem(state.columnConfig.byId, sorts);
  });
  var itemStyle = visible ? {
    color: '#02B980',
    backgroundColor: '#f2f2f2',
    fontWeight: '500'
  } : {};

  var updateBeforeSortStart = function updateBeforeSortStart(_ref2) {
    var index = _ref2.index;
    setDragIndex(index);
  };

  var onSortEnd = function onSortEnd(_ref3) {
    var oldIndex = _ref3.oldIndex,
        newIndex = _ref3.newIndex;
    setDragIndex(-1);

    var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
      draft = (0, _arrayMove.arrayMoveMutable)(draft, oldIndex, newIndex);
    });

    manager.getActions().updateSort(_sorts);
    triggerOnChange({
      type: 'move'
    }, 'sort', true);
  };

  return /*#__PURE__*/_react.default.createElement(_dropdown.default, {
    overlay: /*#__PURE__*/_react.default.createElement("div", {
      className: "".concat(prefixCls, "-toolbar-sort-content")
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "".concat(prefixCls, "-toolbar-sort-title")
    }, "\u8BBE\u7F6E\u6392\u5E8F\u6761\u4EF6"), /*#__PURE__*/_react.default.createElement(_SortRuleList.SortRuleList, {
      prefixCls: prefixCls,
      items: sorts,
      updateBeforeSortStart: updateBeforeSortStart,
      dragIndex: dragIndex,
      onSortEnd: onSortEnd,
      useDragHandle: true
    }), sorts.length < sortRulesLengthUpperLimit && firstItem && /*#__PURE__*/_react.default.createElement(_SortRuleCreateButton.SortRuleCreateButton, {
      prefixCls: prefixCls,
      firstItem: firstItem
    })),
    overlayClassName: "".concat(prefixCls, "-toolbar-sort-dropdown"),
    trigger: ['click'],
    visible: visible,
    onVisibleChange: function onVisibleChange(v) {
      setVisible(v);
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-toolbar-item"),
    style: _objectSpread({}, itemStyle)
  }, /*#__PURE__*/_react.default.createElement(_space.default, {
    size: 7
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "icon-paixu"
  }), "\u6392\u5E8F")));
};

var _default = Sort;
exports.default = _default;