"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/space/style");

var _space = _interopRequireDefault(require("antd/es/space"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash"));

var _LineHeight = _interopRequireDefault(require("./LineHeight"));

var _Sort = _interopRequireDefault(require("./Sort"));

var _FieldConfig = _interopRequireDefault(require("./FieldConfig"));

var _GlobalShow = _interopRequireDefault(require("./GlobalShow"));

require("./index.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Toolbar = function Toolbar(props) {
  var prefixCls = props.prefixCls,
      _props$slots = props.slots,
      slots = _props$slots === void 0 ? [] : _props$slots;
  var defaultSlots = [{
    name: 'fieldConfig',
    position: 'left',
    order: 1,
    render: function render() {
      return /*#__PURE__*/_react.default.createElement(_FieldConfig.default, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldSort',
    position: 'left',
    order: 2,
    render: function render() {
      return /*#__PURE__*/_react.default.createElement(_Sort.default, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldFilter',
    position: 'left',
    order: 3,
    render: function render() {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefixCls, "-toolbar-item")
      }, /*#__PURE__*/_react.default.createElement(_space.default, null, /*#__PURE__*/_react.default.createElement("i", {
        className: "icon-shaixuan"
      }), "\u7B5B\u9009"));
    }
  }, {
    name: 'fieldLineHeight',
    position: 'left',
    order: 4,
    render: function render() {
      return /*#__PURE__*/_react.default.createElement(_LineHeight.default, {
        prefixCls: prefixCls
      });
    }
  }, {
    name: 'fieldGlobalView',
    position: 'right',
    order: 5,
    render: function render() {
      return /*#__PURE__*/_react.default.createElement(_GlobalShow.default, {
        prefixCls: prefixCls
      });
    }
  }];

  var _useMemo = (0, _react.useMemo)(function () {
    var LeftNodes = _lodash.default.unionBy(slots === null || slots === void 0 ? void 0 : slots.filter(function (slot) {
      return slot.position === 'left';
    }), defaultSlots.slice(0, 4), 'order').sort(function (a, b) {
      return a.order - b.order;
    }),
        RightNodes = _lodash.default.unionBy(slots === null || slots === void 0 ? void 0 : slots.filter(function (slot) {
      return slot.position === 'right';
    }), defaultSlots.slice(4), 'order').sort(function (a, b) {
      return a.order - b.order;
    });

    return [LeftNodes, RightNodes];
  }, [slots]),
      _useMemo2 = _slicedToArray(_useMemo, 2),
      LeftNodes = _useMemo2[0],
      RightNodes = _useMemo2[1];

  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar"))
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-left"))
  }, /*#__PURE__*/_react.default.createElement(_space.default, {
    size: 16
  }, LeftNodes.map(function (node) {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: node.order
    }, node.render());
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-toolbar-right"))
  }, /*#__PURE__*/_react.default.createElement(_space.default, {
    size: 16
  }, RightNodes.map(function (node) {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: node.order
    }, node.render());
  }))));
};

var _default = Toolbar;
exports.default = _default;