"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createColumnConfigActions = createColumnConfigActions;
exports.createGlobalShowActions = createGlobalShowActions;
exports.createSizeActions = createSizeActions;
exports.createSortsActions = createSortsActions;

var _utils = require("../utils");

var _size = require("./size");

var _columnConfig = require("./columnConfig");

var _sorts = require("./sorts");

var _isGlobalShow = require("./isGlobalShow");

function createSizeActions(manager) {
  var actions = (0, _utils.combineFuncs)({
    updateSize: _size.updateSize
  }, manager);
  return actions;
}

function createColumnConfigActions(manager) {
  var actions = (0, _utils.combineFuncs)({
    addColumnConfig: _columnConfig.addColumnConfig,
    updateColumnConfig: _columnConfig.updateColumnConfig,
    removeColumnConfig: _columnConfig.removeColumnConfig,
    resetColumnConfig: _columnConfig.resetColumnConfig
  }, manager);
  return actions;
}

function createSortsActions(manager) {
  var actions = (0, _utils.combineFuncs)({
    addSort: _sorts.addSort,
    updateSort: _sorts.updateSort,
    removeSort: _sorts.removeSort,
    resetSorts: _sorts.resetSorts
  }, manager);
  return actions;
}

function createGlobalShowActions(manager) {
  var actions = (0, _utils.combineFuncs)({
    updateGlobalShow: _isGlobalShow.updateGlobalShow
  }, manager);
  return actions;
}