"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UPDATE_SORT = exports.RESET_SORTS = exports.REMOVE_SORT = exports.ADD_SORT = void 0;
exports.addSort = addSort;
exports.removeSort = removeSort;
exports.resetSorts = resetSorts;
exports.updateSort = updateSort;
var ADD_SORT = 'artTable/addSort';
exports.ADD_SORT = ADD_SORT;
var REMOVE_SORT = 'artTable/removeSort';
exports.REMOVE_SORT = REMOVE_SORT;
var UPDATE_SORT = 'artTable/updateSort';
exports.UPDATE_SORT = UPDATE_SORT;
var RESET_SORTS = 'artTable/resetSorts';
exports.RESET_SORTS = RESET_SORTS;

function addSort(manager) {
  return function (payload) {
    if (manager) {
      return {
        type: ADD_SORT,
        payload: payload
      };
    }
  };
}

function updateSort(manager) {
  return function (payload) {
    if (manager) {
      return {
        type: UPDATE_SORT,
        payload: payload
      };
    }
  };
}

function removeSort(manager) {
  return function (payload) {
    if (manager) {
      return {
        type: REMOVE_SORT,
        payload: payload
      };
    }
  };
}

function resetSorts(manager) {
  return function (payload) {
    if (manager) {
      return {
        type: RESET_SORTS,
        payload: payload
      };
    }
  };
}