"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createColumnConfigActions = createColumnConfigActions;
exports.createGlobalShowActions = createGlobalShowActions;
exports.createSizeActions = createSizeActions;
exports.createSortsActions = createSortsActions;

var _size = require("./size");

var _columnConfig = require("./columnConfig");

var _sorts = require("./sorts");

var _isGlobalShow = require("./isGlobalShow");

function createSizeActions() {
  var actions = {
    updateSize: _size.updateSize
  };
  return actions;
}

function createColumnConfigActions() {
  var actions = {
    addColumnConfig: _columnConfig.addColumnConfig,
    updateColumnConfig: _columnConfig.updateColumnConfig,
    removeColumnConfig: _columnConfig.removeColumnConfig,
    resetColumnConfig: _columnConfig.resetColumnConfig
  };
  return actions;
}

function createSortsActions() {
  var actions = {
    addSort: _sorts.addSort,
    updateSort: _sorts.updateSort,
    removeSort: _sorts.removeSort,
    resetSorts: _sorts.resetSorts
  };
  return actions;
}

function createGlobalShowActions() {
  var actions = {
    updateIsGlobalShow: _isGlobalShow.updateIsGlobalShow
  };
  return actions;
}