"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateColumnConfig = exports.resetColumnConfig = exports.removeColumnConfig = exports.default = exports.addColumnConfig = void 0;

var _toolkit = require("@reduxjs/toolkit");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var columnConfigSlice = (0, _toolkit.createSlice)({
  name: 'columnConfig',
  initialState: {
    state: {
      byId: []
    }
  },
  reducers: {
    addColumnConfig: function addColumnConfig(state, action) {
      var _action$payload;

      if ((_action$payload = action.payload) === null || _action$payload === void 0 ? void 0 : _action$payload.column.dataIndex) {
        var _action$payload2, _action$payload3;

        state[(_action$payload2 = action.payload) === null || _action$payload2 === void 0 ? void 0 : _action$payload2.column.dataIndex] = _objectSpread({}, (_action$payload3 = action.payload) === null || _action$payload3 === void 0 ? void 0 : _action$payload3.column);
      }
    },
    updateColumnConfig: function updateColumnConfig(state, action) {
      if (action.payload) {
        state.byId = action.payload;
      }
    },
    removeColumnConfig: function removeColumnConfig(state, action) {
      var _action$payload4;

      if ((_action$payload4 = action.payload) === null || _action$payload4 === void 0 ? void 0 : _action$payload4.column.dataIndex) {
        var _action$payload5;

        delete state.byId[(_action$payload5 = action.payload) === null || _action$payload5 === void 0 ? void 0 : _action$payload5.column.dataIndex];
      }
    },
    resetColumnConfig: function resetColumnConfig(state, action) {
      var _action$payload6;

      state.byId = (_action$payload6 = action.payload) === null || _action$payload6 === void 0 ? void 0 : _action$payload6.columns;
    }
  }
});
var _columnConfigSlice$ac = columnConfigSlice.actions,
    addColumnConfig = _columnConfigSlice$ac.addColumnConfig,
    updateColumnConfig = _columnConfigSlice$ac.updateColumnConfig,
    removeColumnConfig = _columnConfigSlice$ac.removeColumnConfig,
    resetColumnConfig = _columnConfigSlice$ac.resetColumnConfig;
exports.resetColumnConfig = resetColumnConfig;
exports.removeColumnConfig = removeColumnConfig;
exports.updateColumnConfig = updateColumnConfig;
exports.addColumnConfig = addColumnConfig;
var _default = columnConfigSlice.reducer;
exports.default = _default;