"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/es/dropdown"));

require("antd/es/menu/style");

var _menu = _interopRequireDefault(require("antd/es/menu"));

require("antd/es/message/style");

var _message2 = _interopRequireDefault(require("antd/es/message"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash"));

var _immer = _interopRequireDefault(require("immer"));

var _reactRedux = require("react-redux");

var _ArtTableHelpContext = require("../../core/ArtTableHelpContext");

var _ArtTableContext = require("../../core/ArtTableContext");

require("./index.css");

var _sortMap;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var sortMap = (_sortMap = {
  az: {
    asc: '按 A 到 Z 排序',
    desc: '按 Z 到 A 排序'
  }
}, _defineProperty(_sortMap, '09', {
  asc: '按 0 到 9 排序',
  desc: '按 9 到 0 排序'
}), _defineProperty(_sortMap, "zf", {
  asc: '正向排序',
  desc: '倒向排序'
}), _sortMap);

function FilterDropdown(_ref) {
  var prefixCls = _ref.prefixCls,
      column = _ref.column,
      title = _ref.title,
      columnKey = _ref.columnKey,
      filter = _ref.filter,
      sort = _ref.sort,
      triggerFilter = _ref.triggerFilter,
      children = _ref.children;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isShowIcon = _useState2[0],
      setIsShowIcon = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      visible = _useState4[0],
      setVisible = _useState4[1];

  var _useContext = (0, _react.useContext)(_ArtTableHelpContext.ArtTableHelpContext),
      triggerOnChange = _useContext.triggerOnChange,
      isTableScroll = _useContext.isTableScroll,
      isTableColumnResize = _useContext.isTableColumnResize,
      checkedColumnLengthLowerLimit = _useContext.checkedColumnLengthLowerLimit,
      fixedColumnLengthUpperLimit = _useContext.fixedColumnLengthUpperLimit;

  var _useContext2 = (0, _react.useContext)(_ArtTableContext.ArtTableContext),
      manager = _useContext2.manager;

  var isFixed = (column === null || column === void 0 ? void 0 : column.fixed) === 'left';
  var realIndex = (0, _reactRedux.useSelector)(function (state) {
    return state.columnConfig.byId.findIndex(function (c) {
      return c.key === columnKey || c.dataIndex === columnKey;
    });
  });
  var realSort = (0, _reactRedux.useSelector)(function (state) {
    var _item = state.sorts.find(function (s) {
      return s.key === columnKey;
    });

    if (!_item) {
      return [];
    }

    return (_item === null || _item === void 0 ? void 0 : _item.rule) === 'asc' ? ['sortAsc'] : ['sortDesc'];
  });
  (0, _react.useEffect)(function () {
    if (isTableScroll) {
      setVisible(false);
      setIsShowIcon(false);
    }
  }, [isTableScroll]);
  var items = [];

  if (filter === true || (filter === null || filter === void 0 ? void 0 : filter.hidden) !== false) {
    items.push({
      key: 'hiddenField',
      label: /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item")),
        onClick: function onClick() {
          var _ColumnConfig = (0, _immer.default)(manager.getState().columnConfig.byId, function (draft) {
            var isUpperLimit = draft.filter(function (v) {
              return v.fixed !== 'left' && v.fixed !== 'right' && !v.hidden;
            }).length <= checkedColumnLengthLowerLimit;

            if (isUpperLimit && !isFixed) {
              _message2.default.error("\u975E\u56FA\u5B9A\u5217\u6570\u91CF\u4E0D\u80FD\u5C11\u4E8E".concat(checkedColumnLengthLowerLimit, "\u4E2A!"));
            } else {
              draft[realIndex].hidden = !draft[realIndex].hidden;
            }
          });

          manager.getActions().updateColumnConfig(_ColumnConfig);
          triggerOnChange({
            type: 'hidden',
            index: realIndex
          }, 'fieldConfig');
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('icon-yincang1', "".concat(prefixCls, "-dropdown-icon"))
      }), "\u9690\u85CF\u5B57\u6BB5/\u5217")
    });
  }

  if (!_lodash.default.isUndefined(sort) && sort !== false) {
    var _column$sort2, _column$sort3, _column$sort5, _column$sort6;

    items.push({
      key: 'sortAsc',
      label: /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item")),
        onClick: function onClick() {
          var sorts = manager.getState().sorts;

          var _index = sorts.findIndex(function (s) {
            return (s === null || s === void 0 ? void 0 : s.key) === columnKey;
          });

          if (_index !== -1) {
            var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
              draft[_index].rule = 'asc';
            });

            manager.getActions().updateSort(_sorts);
            triggerOnChange({
              type: 'trigger',
              rule: 'asc',
              order: _index
            }, 'sort', true);
          } else {
            var _column$sort;

            manager.getActions().addSort({
              rule: {
                key: columnKey,
                title: title,
                type: (column === null || column === void 0 ? void 0 : (_column$sort = column.sort) === null || _column$sort === void 0 ? void 0 : _column$sort.type) || 'zf',
                rule: 'asc',
                isDefault: false
              }
            });
            triggerOnChange({
              type: 'add'
            }, 'sort', true);
          }
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('icon-zhengxu', "".concat(prefixCls, "-dropdown-icon"))
      }), (column === null || column === void 0 ? void 0 : (_column$sort2 = column.sort) === null || _column$sort2 === void 0 ? void 0 : _column$sort2.type) ? sortMap[column === null || column === void 0 ? void 0 : (_column$sort3 = column.sort) === null || _column$sort3 === void 0 ? void 0 : _column$sort3.type].asc : sortMap.zf.asc)
    }, {
      key: 'sortDesc',
      label: /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item")),
        onClick: function onClick() {
          var sorts = manager.getState().sorts;

          var _index = sorts.findIndex(function (s) {
            return (s === null || s === void 0 ? void 0 : s.key) === columnKey;
          });

          if (_index !== -1) {
            var _sorts = (0, _immer.default)(manager.getState().sorts, function (draft) {
              draft[_index].rule = 'desc';
            });

            manager.getActions().updateSort(_sorts);
            triggerOnChange({
              type: 'trigger',
              rule: 'desc',
              order: _index
            }, 'sort', true);
          } else {
            var _column$sort4;

            manager.getActions().addSort({
              rule: {
                key: columnKey,
                title: title,
                type: (column === null || column === void 0 ? void 0 : (_column$sort4 = column.sort) === null || _column$sort4 === void 0 ? void 0 : _column$sort4.type) || 'zf',
                rule: 'desc',
                isDefault: false
              }
            });
            triggerOnChange({
              type: 'add'
            }, 'sort', true);
          }
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('icon-daoxu', "".concat(prefixCls, "-dropdown-icon"))
      }), (column === null || column === void 0 ? void 0 : (_column$sort5 = column.sort) === null || _column$sort5 === void 0 ? void 0 : _column$sort5.type) ? sortMap[column === null || column === void 0 ? void 0 : (_column$sort6 = column.sort) === null || _column$sort6 === void 0 ? void 0 : _column$sort6.type].desc : sortMap.zf.desc)
    });
  }

  if (filter === true || (filter === null || filter === void 0 ? void 0 : filter.field) === true) {
    items.push({
      key: 'fieldFilter',
      label: /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item")),
        onClick: function onClick() {
          triggerFilter({
            column: column
          });
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('icon-shaixuan', "".concat(prefixCls, "-dropdown-icon"))
      }), "\u6309", ' ', /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item-field-name"))
      }, title), "\u7B5B\u9009")
    });
  }

  if (filter === true || (filter === null || filter === void 0 ? void 0 : filter.fixed) !== false) {
    items.push({
      key: 'fixed',
      disabled: realIndex > 3,
      label: /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _classnames.default)("".concat(prefixCls, "-dropdown-item"), _defineProperty({}, "".concat(prefixCls, "-dropdown-item-disabled"), realIndex > 3)),
        onClick: function onClick() {
          if (realIndex <= 3) {
            var _ColumnConfig = (0, _immer.default)(manager.getState().columnConfig.byId, function (draft) {
              for (var i = 0; i <= realIndex; i++) {
                draft[i].fixed = 'left';
              }

              for (var _i2 = realIndex + 1; _i2 <= fixedColumnLengthUpperLimit - 1; _i2++) {
                draft[_i2].fixed = false;
              }
            });

            manager.getActions().updateColumnConfig(_ColumnConfig);
            triggerOnChange({
              type: 'fixed',
              index: realIndex
            }, 'fieldConfig');
          }
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: (0, _classnames.default)('icon-dongjielie', "".concat(prefixCls, "-dropdown-icon"))
      }), "\u51BB\u7ED3\u81F3\u8BE5\u5217")
    });
  }

  var realItems = [];
  items.forEach(function (l, i) {
    realItems.push(l);

    if (l.key === 'sortAsc' || i === items.length - 1) {
      return;
    }

    realItems.push({
      type: 'divider'
    });
  });

  var menu = /*#__PURE__*/_react.default.createElement(_menu.default, {
    onClick: function onClick() {
      setVisible(false);
      setIsShowIcon(false);
    },
    items: realItems,
    selectedKeys: realSort
  });

  return /*#__PURE__*/_react.default.createElement(_dropdown.default, {
    overlay: menu,
    overlayClassName: (0, _classnames.default)("".concat(prefixCls, "-dropdown")),
    overlayStyle: {
      minWidth: '154px',
      maxWidth: '210px'
    },
    trigger: ['click'],
    visible: visible && realItems.length > 0,
    onVisibleChange: function onVisibleChange(v) {
      if (v === false) {
        setVisible(v);
      }
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)("".concat(prefixCls, "-column")),
    onMouseEnter: function onMouseEnter() {
      if (!isTableColumnResize) {
        setIsShowIcon(true);
      }
    },
    onMouseLeave: function onMouseLeave() {
      if (!isTableColumnResize) {
        setIsShowIcon(false);
      }
    }
  }, children, filter !== false && /*#__PURE__*/_react.default.createElement("span", {
    className: (0, _classnames.default)("".concat(prefixCls, "-column-icon").concat(visible ? '-visible' : ''))
  }, (isShowIcon || visible) && /*#__PURE__*/_react.default.createElement("i", {
    className: visible ? 'icon-shangla1' : 'icon-xiala1',
    onClick: function onClick(e) {
      e.stopPropagation();
      setVisible(!visible);
    },
    style: {
      fontSize: '24px',
      color: visible ? '#02B980' : '#999999',
      cursor: 'pointer'
    }
  }))));
}

var _default = FilterDropdown;
exports.default = _default;