"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.renderColumnTitle = renderColumnTitle;

var React = _interopRequireWildcard(require("react"));

var _utils = require("../../utils");

var _FilterDropdown = _interopRequireDefault(require("./FilterDropdown"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function renderColumnTitle(title, icon, props, prefixCls) {
  var Icon = icon ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filter-icon")
  }, typeof icon === 'function' ? icon(props) : icon) : null;
  var Title = title ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filter-title")
  }, typeof title === 'function' ? title(props) : title) : null;
  return /*#__PURE__*/React.createElement(React.Fragment, null, Icon, Title);
}

function injectFilter(prefixCls, columns, onFilterChange, pos) {
  return columns.map(function (column, index) {
    var _newColumn;

    var columnPos = (0, _utils.getColumnPos)(index, pos);

    _objectDestructuringEmpty(column);

    var newColumn = column;
    var columnKey = (0, _utils.getColumnKey)(newColumn, columnPos);
    newColumn = _objectSpread(_objectSpread({}, newColumn), {}, {
      minWidth: parseFloat((_newColumn = newColumn) === null || _newColumn === void 0 ? void 0 : _newColumn.minWidth),
      title: function title(renderProps) {
        return /*#__PURE__*/React.createElement(_FilterDropdown.default, {
          tablePrefixCls: prefixCls,
          prefixCls: "".concat(prefixCls, "-filter"),
          title: column.textTitle || column.title,
          column: newColumn,
          columnKey: columnKey,
          dIndex: index,
          sort: newColumn.sort,
          filter: newColumn.filter,
          triggerFilter: onFilterChange
        }, renderColumnTitle(column.title, column.icon, renderProps, prefixCls));
      }
    });
    return newColumn;
  });
}

function useFilter(_ref) {
  var prefixCls = _ref.prefixCls,
      onFilterChange = _ref.onFilterChange;

  var transformColumns = function transformColumns(innerColumns) {
    return injectFilter(prefixCls, innerColumns, onFilterChange);
  };

  return [transformColumns, null];
}

var _default = useFilter;
exports.default = _default;