"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useTable;

var _toolkit = require("@reduxjs/toolkit");

var _reducers = require("../core/reducers");

var _ArtTableManager = require("../core/classes/ArtTableManager");

function useTable(tableConfig) {
  var store = (0, _toolkit.configureStore)({
    reducer: (0, _reducers.artTableReducers)(),
    preloadedState: (0, _reducers.getInitialState)(tableConfig),
    devTools: !!(tableConfig === null || tableConfig === void 0 ? void 0 : tableConfig.devTools)
  });
  var manager = new _ArtTableManager.ArtTableManagerImpl(store);
  return manager;
}