"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.computedColumn = void 0;
exports.formatTableStoreInInImmutable = formatTableStoreInInImmutable;
exports.getColumnKey = getColumnKey;
exports.getColumnPos = getColumnPos;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getColumnKey(column, defaultKey) {
  if ('key' in column && column.key !== undefined && column.key !== null) {
    return column.key;
  }

  if (column.dataIndex) {
    return Array.isArray(column.dataIndex) ? column.dataIndex.join('.') : column.dataIndex;
  }

  return defaultKey;
}

function getColumnPos(index, pos) {
  return pos ? "".concat(pos, "-").concat(index) : "".concat(index);
}
/**
 * 过滤无效数据,只保留可以序列化的数据给表格存储
 */


function formatTableStoreInInImmutable(columns) {
  return columns === null || columns === void 0 ? void 0 : columns.map(function (c) {
    return _lodash.default.omit(c, ['icon', 'render', 'summaryRender', 'shouldCellUpdate', 'summaryTitle']);
  });
}

var computedColumn = function computedColumn(dataColumns, columns) {
  var isFilter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var r = dataColumns === null || dataColumns === void 0 ? void 0 : dataColumns.map(function (c) {
    var _c = _lodash.default.find(columns, function (v) {
      return !_lodash.default.isNil(v === null || v === void 0 ? void 0 : v.dataIndex) && (v === null || v === void 0 ? void 0 : v.dataIndex) === (c === null || c === void 0 ? void 0 : c.dataIndex);
    }) || {};

    return _objectSpread(_objectSpread(_objectSpread({}, _c), c), {}, {
      width: (c === null || c === void 0 ? void 0 : c.width) || (_c === null || _c === void 0 ? void 0 : _c.width)
    });
  });

  if (isFilter) {
    return r === null || r === void 0 ? void 0 : r.filter(function (item) {
      return (item === null || item === void 0 ? void 0 : item.hidden) !== true;
    });
  }

  return r;
};

exports.computedColumn = computedColumn;