import * as React from 'react';
import type { HeaderProps, HeaderInnerProps } from '../Header/Header';
export declare function fillRef<T>(ref: React.Ref<T>, node: T): void;
export interface FixedHeaderProps<RecordType> extends HeaderProps<RecordType> {
    className: string;
    noData: boolean;
    maxContentScroll: boolean;
    colWidths: readonly number[];
    columCount: number;
    direction: 'ltr' | 'rtl';
    fixHeader: boolean;
    stickyTopOffset?: number;
    stickyBottomOffset?: number;
    fixedHeight?: any;
    stickyClassName?: string;
    scrollTableStyle?: any;
    children: (info: HeaderProps<RecordType> & HeaderInnerProps) => React.ReactNode;
}
declare const FixedHolder: React.ForwardRefExoticComponent<FixedHeaderProps<unknown> & React.RefAttributes<HTMLDivElement>>;
export default FixedHolder;
