/// <reference types="react" />
import type { ColumnsType, ColumnType, StickyOffsets, GetComponentProps } from '../types';
declare type FlattenColumns<RecordType> = readonly (ColumnType<RecordType> & {
    scrollbar?: boolean;
})[];
export interface FooterProps<RecordType> {
    data?: RecordType;
    stickyOffsets: StickyOffsets;
    columns: ColumnsType<RecordType>;
    flattenColumns: FlattenColumns<RecordType>;
    colWidths: readonly (number | string)[];
    columCount?: number;
    onSummaryRow?: GetComponentProps<readonly ColumnType<RecordType>[]>;
}
declare function Footer<RecordType>({ data, stickyOffsets, columns, colWidths, flattenColumns, columCount, onSummaryRow, }: FooterProps<RecordType>): JSX.Element;
export default Footer;
