/// <reference types="react" />
import type { CellType, StickyOffsets, ColumnType, GetComponentProps, GetCellComponentProps } from '../types';
export interface RowProps<RecordType> {
    cells: readonly CellType<RecordType>[];
    stickyOffsets: StickyOffsets;
    flattenColumns: readonly ColumnType<RecordType>[];
    onHeaderCell: GetCellComponentProps<RecordType>;
    onHeaderRow: GetComponentProps<readonly ColumnType<RecordType>[]>;
    index: number;
    colWidths: readonly (number | string)[];
    scrollBodyTranslateX?: number;
}
declare function HeaderRow<RecordType>({ cells, stickyOffsets, flattenColumns, onHeaderCell, onHeaderRow, index, colWidths, scrollBodyTranslateX, }: RowProps<RecordType>): JSX.Element;
declare namespace HeaderRow {
    var displayName: string;
}
export default HeaderRow;
