"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.isVisible = isVisible;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _rcResizeObserver = _interopRequireDefault(require("rc-resize-observer"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

var _lodash = _interopRequireDefault(require("lodash"));

var _ahooks = require("ahooks");

var _Scrollbar = _interopRequireDefault(require("./Scrollbar"));

var _useSortable3 = _interopRequireDefault(require("./hooks/useSortable"));

var _useColumns3 = _interopRequireDefault(require("./hooks/useColumns"));

var _useFrame = require("./hooks/useFrame");

var _useStickyOffsets = _interopRequireDefault(require("./hooks/useStickyOffsets"));

var _useSticky2 = _interopRequireDefault(require("./hooks/useSticky"));

var _valueUtil = require("./utils/valueUtil");

var _fixUtil = require("./utils/fixUtil");

var _FixedHolder = _interopRequireDefault(require("./FixedHolder"));

var _FixedHolderLine = _interopRequireDefault(require("./FixedHolder/FixedHolderLine"));

var _Header = _interopRequireDefault(require("./Header/Header"));

var _TableContext = _interopRequireDefault(require("./context/TableContext"));

var _BodyContext = _interopRequireDefault(require("./context/BodyContext"));

var _ExtraRowContext = _interopRequireDefault(require("./context/ExtraRowContext"));

var _ResizeContext = _interopRequireDefault(require("./context/ResizeContext"));

var _Body = _interopRequireDefault(require("./Body"));

var _ExtraRow = _interopRequireDefault(require("./Body/ExtraRow"));

var _Footer = _interopRequireDefault(require("./Footer"));

require("./style/index.css");

var _pickAttrs = _interopRequireDefault(require("./utils/pickAttrs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function isVisible(element) {
  if (!element) {
    return false;
  }

  if (element instanceof HTMLElement && element.offsetParent) {
    return true;
  }

  if (element instanceof SVGGraphicsElement && element.getBBox) {
    var _element$getBBox = element.getBBox(),
        width = _element$getBBox.width,
        height = _element$getBBox.height;

    if (width || height) {
      return true;
    }
  }

  if (element instanceof HTMLElement && element.getBoundingClientRect) {
    var _element$getBoundingC = element.getBoundingClientRect(),
        _width = _element$getBoundingC.width,
        _height = _element$getBoundingC.height;

    if (_width || _height) {
      return true;
    }
  }

  return false;
}

var EMPTY_DATA = []; // Used for customize scroll

var EMPTY_SCROLL_TARGET = {};

var MemoTableContent = /*#__PURE__*/_react.default.memo(function (_ref) {
  var children = _ref.children;
  return children;
}, function (prev, next) {
  if (!(0, _shallowequal.default)(prev.props, next.props)) {
    return false;
  } // No additional render when pinged status change.
  // This is not a bug.


  return prev.pingLeft !== next.pingLeft || prev.pingRight !== next.pingRight;
});

function Table(props) {
  var _classNames;

  var prefixCls = props.prefixCls,
      className = props.className,
      style = props.style,
      data = props.data,
      rowKey = props.rowKey,
      scroll = props.scroll,
      direction = props.direction,
      id = props.id,
      emptyText = props.emptyText,
      onCell = props.onCell,
      onRow = props.onRow,
      onHeaderCell = props.onHeaderCell,
      onHeaderRow = props.onHeaderRow,
      onSummaryRow = props.onSummaryRow,
      rowClassName = props.rowClassName,
      onScrollbarStart = props.onScrollbarStart,
      onScrollbarStop = props.onScrollbarStop,
      onColumnResizeStart = props.onColumnResizeStart,
      onColumnResizeStop = props.onColumnResizeStop,
      selectedColor = props.selectedColor,
      itemHeight = props.itemHeight,
      summaryHeight = props.summaryHeight,
      cellExtraRender = props.cellExtraRender,
      getExtraState = props.getExtraState,
      transformColumns = props.transformColumns,
      internalRefs = props.internalRefs;
  var mergedData = data || EMPTY_DATA;
  var hasData = !!mergedData.length;

  var getRowKey = _react.default.useMemo(function () {
    if (typeof rowKey === 'function') {
      return rowKey;
    }

    return function (record) {
      var key = record && record[rowKey];

      if (process.env.NODE_ENV !== 'production' && key === undefined) {
        console.error('Each record in table should have a unique `key` prop, or set `rowKey` to an unique primary key.');
      }

      return key;
    };
  }, [rowKey]); // ====================== virtual list ======================


  var _React$useState = _react.default.useState({
    list: [],
    lastStartIndex: 0
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      showData = _React$useState2[0],
      setShowData = _React$useState2[1];

  var lastStartIndex = _react.default.useRef(null);

  var lastEndIndex = _react.default.useRef(null);

  var viewMaxNum = _react.default.useRef(null);

  var viewMaxHeight = _react.default.useRef(0);

  var blankFill = _react.default.useRef(null); // const viewTotal = React.useRef(data?.length || 0);
  // ====================== sortable =======================


  var _useSortable = (0, _useSortable3.default)(),
      _useSortable2 = _slicedToArray(_useSortable, 2),
      sortableStore = _useSortable2[0],
      sortableDispatch = _useSortable2[1]; // ====================== Column ======================


  var _React$useState3 = _react.default.useState(0),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      componentWidth = _React$useState4[0],
      setComponentWidth = _React$useState4[1];

  var _useColumns = (0, _useColumns3.default)(_objectSpread(_objectSpread({}, props), {}, {
    getRowKey: getRowKey,
    direction: direction
  }), transformColumns),
      _useColumns2 = _slicedToArray(_useColumns, 2),
      columns = _useColumns2[0],
      flattenColumns = _useColumns2[1];

  var columnContext = _react.default.useMemo(function () {
    return {
      columns: columns,
      flattenColumns: flattenColumns
    };
  }, [columns, flattenColumns]); // ====================== Scroll ======================


  var fullTableRef = _react.default.useRef(); // const scrollLineRef = React.useRef<any>();


  var scrollHeaderRef = _react.default.useRef();

  var scrollBodyRef = _react.default.useRef();

  var bodyInnerRef = _react.default.useRef();

  var scrollBodyContainerRef = _react.default.useRef();

  var scrollSummaryRef = _react.default.useRef();

  var _React$useState5 = _react.default.useState(false),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      pingedLeft = _React$useState6[0],
      setPingedLeft = _React$useState6[1];

  var _React$useState7 = _react.default.useState(false),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      pingedRight = _React$useState8[0],
      setPingedRight = _React$useState8[1];

  var _useLayoutState = (0, _useFrame.useLayoutState)(new Map()),
      _useLayoutState2 = _slicedToArray(_useLayoutState, 2),
      colsWidths = _useLayoutState2[0],
      updateColsWidths = _useLayoutState2[1]; // Convert map to number width


  var colsKeys = (0, _valueUtil.getColumnsKey)(flattenColumns);
  var pureColWidths = colsKeys.map(function (columnKey) {
    return colsWidths.get(columnKey);
  });

  var colWidths = _react.default.useMemo(function () {
    return pureColWidths;
  }, [pureColWidths.join('_')]);

  var stickyOffsets = (0, _useStickyOffsets.default)(colWidths, flattenColumns.length, direction);
  var fixHeader = scroll && (0, _valueUtil.validateValue)(scroll.y);
  var horizonScroll = scroll && (0, _valueUtil.validateValue)(scroll.x);
  var fixColumn = horizonScroll && flattenColumns.some(function (_ref2) {
    var fixed = _ref2.fixed;
    return fixed;
  }); // Sticky

  var stickyRef = _react.default.useRef();

  var _useSticky = (0, _useSticky2.default)(prefixCls),
      isSticky = _useSticky.isSticky,
      offsetHeader = _useSticky.offsetHeader,
      offsetSummary = _useSticky.offsetSummary; // Footer (Fix footer must fixed header)


  var fixFooter = (fixHeader || isSticky) && flattenColumns.some(function (v) {
    return !_lodash.default.isUndefined(v.summaryRender) || !_lodash.default.isUndefined(v.summaryTitle);
  }); // Scroll

  var scrollXStyle;
  var scrollYStyle;
  var scrollTableStyle;

  if (fixHeader) {
    scrollYStyle = {
      overflowY: 'scroll',
      maxHeight: scroll.y
    };
  }

  if (horizonScroll) {
    scrollXStyle = {
      overflowX: 'auto'
    };

    if (!fixHeader) {
      scrollYStyle = {
        overflowY: 'hidden'
      };
    }

    scrollTableStyle = {
      width: (scroll === null || scroll === void 0 ? void 0 : scroll.x) === true ? 'auto' : scroll === null || scroll === void 0 ? void 0 : scroll.x,
      minWidth: '100%'
    };
  }

  if (!fixHeader && !horizonScroll) {
    throw new Error('no scroll,quit!');
  }

  var onColumnResize = _react.default.useCallback(function (columnKey, width) {
    if (isVisible(fullTableRef.current)) {
      updateColsWidths(function (widths) {
        if (widths.get(columnKey) !== width) {
          var newWidths = new Map(widths);
          newWidths.set(columnKey, width);
          return newWidths;
        }

        return widths;
      });
    }
  }, []);

  var _useTimeoutLock = (0, _useFrame.useTimeoutLock)(null),
      _useTimeoutLock2 = _slicedToArray(_useTimeoutLock, 2),
      setScrollTarget = _useTimeoutLock2[0],
      getScrollTarget = _useTimeoutLock2[1];

  function forceScroll(scrollLeft, target) {
    if (!target) {
      return;
    }

    if (typeof target === 'function') {
      target(scrollLeft);
    } else if (target.scrollLeft !== scrollLeft) {
      // eslint-disable-next-line no-param-reassign
      target.scrollLeft = scrollLeft;
    }
  }

  var onScroll = function onScroll(_ref3) {
    var currentTarget = _ref3.currentTarget,
        scrollLeft = _ref3.scrollLeft;
    var isRTL = direction === 'rtl';
    var mergedScrollLeft = typeof scrollLeft === 'number' ? scrollLeft : currentTarget.scrollLeft;
    var compareTarget = currentTarget || EMPTY_SCROLL_TARGET;

    if (!getScrollTarget() || getScrollTarget() === compareTarget) {
      var _scrollHeaderRef$curr, _stickyRef$current, _scrollBodyRef$curren;

      setScrollTarget(compareTarget); //forceScroll(mergedScrollLeft, scrollLineRef.current?.setScrollLeft);

      forceScroll(mergedScrollLeft, (_scrollHeaderRef$curr = scrollHeaderRef.current) === null || _scrollHeaderRef$curr === void 0 ? void 0 : _scrollHeaderRef$curr.setScrollLeft);
      forceScroll(mergedScrollLeft, scrollSummaryRef.current);
      forceScroll(mergedScrollLeft, (_stickyRef$current = stickyRef.current) === null || _stickyRef$current === void 0 ? void 0 : _stickyRef$current.setScrollLeft); // 虚拟滚动条,手动控制

      (_scrollBodyRef$curren = scrollBodyRef.current) === null || _scrollBodyRef$curren === void 0 ? void 0 : _scrollBodyRef$curren.setPosition({
        left: mergedScrollLeft
      });
    }

    if (currentTarget) {
      var scrollWidth = currentTarget.scrollWidth,
          clientWidth = currentTarget.clientWidth; // There is no space to scroll

      if (scrollWidth !== undefined && scrollWidth === clientWidth) {
        setPingedLeft(false);
        setPingedRight(false);
        return;
      }

      if (isRTL) {
        setPingedLeft(-mergedScrollLeft < scrollWidth - clientWidth);
        setPingedRight(-mergedScrollLeft > 0);
      } else {
        setPingedLeft(mergedScrollLeft > 0);
        setPingedRight(mergedScrollLeft < scrollWidth - clientWidth);
      }
    }
  };

  var triggerOnScroll = function triggerOnScroll() {
    if (horizonScroll && scrollBodyRef.current.el) {
      onScroll({
        currentTarget: scrollBodyRef.current.el
      });
    } else {
      setPingedLeft(false);
      setPingedRight(false);
    }
  };

  var onVirtualScroll = function onVirtualScroll(target, type) {
    var startIndex = Math.floor((target === null || target === void 0 ? void 0 : target.scrollTop) / itemHeight);
    if (lastStartIndex.current === startIndex && type !== 'reset') return;
    lastStartIndex.current = startIndex;
    var containerMaxSize = viewMaxNum.current;
    var endIndex = startIndex + 2 * containerMaxSize - 1;
    var currLen = mergedData.length; // 接近滚动到列表底部

    if (endIndex > currLen - 1) {
      endIndex = currLen - 1;
    }

    lastEndIndex.current = endIndex;

    if (startIndex <= containerMaxSize) {
      startIndex = 0;
    } else {
      startIndex = startIndex - containerMaxSize;
    }

    blankFill.current = {
      paddingTop: "".concat(startIndex * itemHeight, "px"),
      paddingBottom: "".concat((mergedData.length - 1 - endIndex) * itemHeight, "px")
    };
    setShowData({
      list: mergedData.slice(startIndex, endIndex + 1),
      lastStartIndex: startIndex
    });
  };

  var onFullTableResize = function onFullTableResize(_ref4) {
    var width = _ref4.width,
        height = _ref4.height;

    if (width !== componentWidth || height !== viewMaxNum.current) {
      var listMaxHeight = scrollBodyRef.current ? scrollBodyRef.current.offsetHeight - summaryHeight : height - summaryHeight;
      var listMaxCount = Math.ceil(listMaxHeight / itemHeight) + 1;
      viewMaxNum.current = listMaxCount;
      viewMaxHeight.current = listMaxHeight;
      triggerOnScroll();
      scrollBodyRef.current.prepareScrollbar();
      setComponentWidth(fullTableRef.current ? fullTableRef.current.offsetWidth : width);
    }
  };

  var mounted = _react.default.useRef(false);

  (0, _react.useEffect)(function () {
    if (mounted.current) {
      triggerOnScroll();
    }
  }, [horizonScroll, columns.length]);
  (0, _ahooks.useDeepCompareEffect)(function () {
    // 特殊处理,针对data的更新,需要强制进行虚拟列表计算
    if (mounted.current) {
      triggerOnScroll();

      if (viewMaxNum.current !== null) {
        onVirtualScroll(scrollBodyRef.current.el, 'reset');
      }
    }
  }, [data]);
  (0, _react.useEffect)(function () {
    if (mounted.current) {
      var listMaxCount = Math.ceil(viewMaxHeight.current / itemHeight) + 1;
      viewMaxNum.current = listMaxCount;
      onVirtualScroll(scrollBodyRef.current.el, 'reset');
    }
  }, [itemHeight]);

  _react.default.useEffect(function () {
    mounted.current = true;
  }, []); // ================== INTERNAL HOOKS ==================


  _react.default.useEffect(function () {
    if (internalRefs) {
      internalRefs.body.current = scrollBodyRef.current;
      internalRefs.container.current = fullTableRef.current;
      internalRefs.bodyInner.current = bodyInnerRef.current;
    }
  }); // ====================== Render ======================


  var groupTableNode; // Header props

  var headerProps = {
    colWidths: colWidths,
    columCount: flattenColumns.length,
    stickyOffsets: stickyOffsets,
    onHeaderCell: onHeaderCell,
    onHeaderRow: onHeaderRow,
    onSummaryRow: onSummaryRow,
    fixHeader: fixHeader,
    scroll: scroll
  }; // Empty

  var emptyNode = _react.default.useMemo(function () {
    if (hasData) {
      return null;
    }

    var _Node = typeof emptyText === 'function' ? emptyText() : emptyText;

    return /*#__PURE__*/_react.default.createElement(_ExtraRow.default, {
      expanded: true,
      className: "".concat(prefixCls, "-empty-placeholder"),
      prefixCls: prefixCls,
      colSpan: flattenColumns.length,
      isEmpty: true
    }, _Node);
  }, [hasData, emptyText]); // Body


  var body = /*#__PURE__*/_react.default.createElement(_Body.default, {
    data: showData,
    measureColumnWidth: fixHeader || horizonScroll || isSticky,
    getRowKey: getRowKey,
    onRow: onRow,
    onCell: onCell
  });

  if (fixHeader) {
    var bodyContent = /*#__PURE__*/_react.default.createElement(_Scrollbar.default, {
      style: _objectSpread(_objectSpread({
        width: '100%',
        height: '100%'
      }, scrollXStyle), scrollYStyle),
      trackSize: "10px",
      onScrollbarScroll: function onScrollbarScroll(target) {
        onScroll({
          currentTarget: target,
          scrollLeft: target.scrollLeft
        });

        if (viewMaxNum.current !== null) {
          onVirtualScroll(target);
        }
      },
      autoHide: true,
      onScrollbarStart: onScrollbarStart,
      onScrollbarStop: onScrollbarStop,
      onScrollbarScrollTimeout: 0,
      fixedOffset: {
        top: 36
      },
      className: (0, _classnames.default)("".concat(prefixCls, "-body")),
      dataSource: mergedData,
      showData: showData,
      ref: scrollBodyRef
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _classnames.default)("".concat(prefixCls, "-body-inner")),
      style: _objectSpread(_objectSpread(_objectSpread({}, scrollTableStyle), blankFill.current), {}, {
        marginBottom: fixFooter ? 33 : 0
      }),
      ref: bodyInnerRef
    }, body));

    headerProps.colWidths = flattenColumns.map(function (_ref5) {
      var width = _ref5.width;
      return width;
    }); // Fixed holder share the props

    var fixedHolderProps = _objectSpread(_objectSpread(_objectSpread({
      noData: !mergedData.length,
      maxContentScroll: horizonScroll && scroll.x === 'max-content'
    }, headerProps), columnContext), {}, {
      direction: direction,
      scrollTableStyle: scrollTableStyle
    });

    groupTableNode = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_FixedHolderLine.default, _objectSpread(_objectSpread({}, fixedHolderProps), {}, {
      stickyTopOffset: offsetHeader,
      className: "".concat(prefixCls, "-header"),
      ref: scrollHeaderRef
    }), function (fixedHolderPassProps) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Header.default, _objectSpread({}, fixedHolderPassProps)));
    }), bodyContent, emptyNode, fixFooter && /*#__PURE__*/_react.default.createElement(_FixedHolder.default, _objectSpread(_objectSpread({}, fixedHolderProps), {}, {
      stickyBottomOffset: offsetSummary,
      className: "".concat(prefixCls, "-summary"),
      ref: scrollSummaryRef
    }), function (fixedHolderPassProps) {
      return /*#__PURE__*/_react.default.createElement(_Footer.default, _objectSpread({
        data: mergedData
      }, fixedHolderPassProps));
    }));
  }

  var ariaProps = (0, _pickAttrs.default)(props, {
    aria: true,
    data: true
  });

  var fullTable = /*#__PURE__*/_react.default.createElement("div", _objectSpread({
    className: (0, _classnames.default)(prefixCls, className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === 'rtl'), _defineProperty(_classNames, "".concat(prefixCls, "-ping-left"), pingedLeft), _defineProperty(_classNames, "".concat(prefixCls, "-ping-right"), pingedRight), _defineProperty(_classNames, "".concat(prefixCls, "-fixed-header"), fixHeader), _defineProperty(_classNames, "".concat(prefixCls, "-fixed-column"), fixColumn), _defineProperty(_classNames, "".concat(prefixCls, "-scroll-horizontal"), horizonScroll), _defineProperty(_classNames, "".concat(prefixCls, "-has-fix-left"), flattenColumns[0] && flattenColumns[0].fixed), _defineProperty(_classNames, "".concat(prefixCls, "-has-fix-right"), flattenColumns[flattenColumns.length - 1] && flattenColumns[flattenColumns.length - 1].fixed === 'right'), _classNames)),
    style: style,
    id: id,
    ref: fullTableRef
  }, ariaProps), /*#__PURE__*/_react.default.createElement(MemoTableContent, {
    pingLeft: pingedLeft,
    pingRight: pingedRight,
    props: _objectSpread(_objectSpread({}, props), {}, {
      stickyOffsets: stickyOffsets
    })
  }, /*#__PURE__*/_react.default.createElement("div", {
    ref: scrollBodyContainerRef,
    className: "".concat(prefixCls, "-container")
  }, groupTableNode)));

  if (horizonScroll) {
    fullTable = /*#__PURE__*/_react.default.createElement(_rcResizeObserver.default, {
      onResize: onFullTableResize
    }, fullTable);
  }

  var TableContextValue = _react.default.useMemo(function () {
    var _scrollBodyRef$curren2;

    return {
      prefixCls: prefixCls,
      direction: direction,
      scrollbarSize: 0,
      fixedInfoList: flattenColumns.map(function (_, colIndex) {
        return (0, _fixUtil.getCellFixedInfo)(colIndex, colIndex, flattenColumns, stickyOffsets, direction);
      }),
      pingedLeft: pingedLeft,
      pingedRight: pingedRight,
      isScroll: (scrollBodyRef === null || scrollBodyRef === void 0 ? void 0 : (_scrollBodyRef$curren2 = scrollBodyRef.current) === null || _scrollBodyRef$curren2 === void 0 ? void 0 : _scrollBodyRef$curren2.scrolling) || false,
      getExtraState: getExtraState,
      selectedColor: selectedColor,
      onColumnResizeStart: onColumnResizeStart,
      onColumnResizeStop: onColumnResizeStop,
      sortableStore: sortableStore,
      sortableDispatch: sortableDispatch,
      summaryHeight: summaryHeight,
      itemHeight: itemHeight,
      viewMaxNum: viewMaxNum.current,
      viewMaxHeight: viewMaxHeight.current,
      lastEndIndex: lastEndIndex.current,
      cellExtraRender: cellExtraRender
    };
  }, [onColumnResizeStart, onColumnResizeStop, prefixCls, direction, flattenColumns, stickyOffsets, pingedLeft, pingedRight, getExtraState, selectedColor, sortableStore, sortableDispatch, summaryHeight, itemHeight, viewMaxNum, viewMaxHeight, lastEndIndex, cellExtraRender]);

  var ResizeContextValue = _react.default.useMemo(function () {
    return {
      onColumnResize: onColumnResize
    };
  }, [onColumnResize]);

  var BodyContextValue = _react.default.useMemo(function () {
    return _objectSpread({
      rowClassName: rowClassName
    }, columnContext);
  }, [columnContext]);

  var ExtraRowContextValue = _react.default.useMemo(function () {
    return {
      componentWidth: componentWidth,
      fixHeader: fixHeader,
      fixColumn: fixColumn,
      horizonScroll: horizonScroll
    };
  }, [componentWidth, fixHeader, fixColumn, horizonScroll]);

  return /*#__PURE__*/_react.default.createElement(_TableContext.default.Provider, {
    value: TableContextValue
  }, /*#__PURE__*/_react.default.createElement(_BodyContext.default.Provider, {
    value: BodyContextValue
  }, /*#__PURE__*/_react.default.createElement(_ExtraRowContext.default.Provider, {
    value: ExtraRowContextValue
  }, /*#__PURE__*/_react.default.createElement(_ResizeContext.default.Provider, {
    value: ResizeContextValue
  }, fullTable))));
}

Table.defaultProps = {
  rowKey: 'key',
  prefixCls: 'kodo-ex-art-table',
  onColumnResizeStart: function onColumnResizeStart() {},
  onColumnResizeStop: function onColumnResizeStop() {},
  emptyText: function emptyText() {
    return 'no data';
  }
};
var _default = Table;
exports.default = _default;