import * as React from 'react';
import type { ColumnsType, ColumnType, FixedType, GetRowKey } from '../types';
export declare function convertChildrenToColumns<RecordType>(children: React.ReactNode): ColumnsType<RecordType>;
/**
 * Parse `columns` & `children` into `columns`.
 */
declare function useColumns<RecordType>({ columns, children, direction, }: {
    prefixCls?: string;
    columns?: ColumnsType<RecordType>;
    children?: React.ReactNode;
    getRowKey: GetRowKey<RecordType>;
    direction?: 'ltr' | 'rtl';
    columnWidth?: number | string;
    fixed?: FixedType;
}, transformColumns: (columns: ColumnsType<RecordType>) => ColumnsType<RecordType>): [ColumnsType<RecordType>, readonly ColumnType<RecordType>[]];
export default useColumns;
