/// <reference types="react" />
export declare type Key = React.Key;
export declare type DataIndex = string | number | readonly (string | number)[];
export declare type AlignType = 'left' | 'center' | 'right';
export declare type DefaultRecordType = Record<string, any>;
export declare type GetComponentProps<DataType> = (data: DataType, index?: number) => React.HTMLAttributes<any> | React.TdHTMLAttributes<any>;
export declare type GetCellComponentProps<DataType> = (data: DataType, rowIndex?: number, columnIndex?: number) => React.HTMLAttributes<any> | React.TdHTMLAttributes<any>;
export declare type GetRowKey<RecordType> = (record: RecordType, index?: number) => Key;
export * from './fixColumn';
export * from './Cell';
export * from './Column';
export * from './Row';
export * from './Sortable';
