"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getElementLeft = void 0;
exports.getParent = getParent;
exports.isTouchEvent = exports.isMouseEvent = void 0;

var isTouchEvent = function isTouchEvent(event) {
  return Boolean(event.touches && event.touches.length);
};

exports.isTouchEvent = isTouchEvent;

var isMouseEvent = function isMouseEvent(event) {
  return Boolean((event.clientX || event.clientX === 0) && (event.clientY || event.clientY === 0));
};

exports.isMouseEvent = isMouseEvent;

var getElementLeft = function getElementLeft(parent, child) {
  var parentClient = parent.getBoundingClientRect();
  var subClient = child.getBoundingClientRect();
  return parseInt(subClient.left - parentClient.left + '');
};

exports.getElementLeft = getElementLeft;

function getParent(el, selector) {
  var parents = [];

  while ((el = el.parentNode) && el !== document) {
    if (!selector || el.matches(selector)) parents.unshift(el);
  }

  return parents;
}