"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _constant = require("../constant");

require("./index.css");

require("../../assets/icomoon/style.css");

var _lodash = require("lodash");

var _ahooks = require("ahooks");

var _ThePopover = _interopRequireDefault(require("../component/ThePopover"));

var _TheEllipsis = _interopRequireDefault(require("../component/TheEllipsis"));

var _ArtTableEditableCellContext = require("../../ArtTable/core/ArtTableEditableCellContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function EditableCell(props) {
  var value = props.value,
      config = props.config,
      _props$mode = props.mode,
      mode = _props$mode === void 0 ? _constant.Mode.Readonly : _props$mode,
      _props$disable = props.disable,
      disable = _props$disable === void 0 ? false : _props$disable,
      editRender = props.editRender,
      readRender = props.readRender,
      editIcon = props.editIcon,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? function () {} : _props$onChange,
      _props$readPadding = props.readPadding,
      readPadding = _props$readPadding === void 0 ? true : _props$readPadding,
      _props$beforeEdit = props.beforeEdit,
      beforeEdit = _props$beforeEdit === void 0 ? function () {
    return Promise.resolve(true);
  } : _props$beforeEdit;

  var _ref = config || {},
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'middle' : _ref$size,
      _ref$isFocusing = _ref.isFocusing,
      isFocusing = _ref$isFocusing === void 0 ? false : _ref$isFocusing;

  var contentRef = (0, _react.useRef)();
  var editMaskRef = (0, _react.useRef)();
  var basicCell = (0, _react.useRef)();

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      editing = _useState2[0],
      setEditing = _useState2[1];

  var wrapConfig = _objectSpread(_objectSpread({}, config), {}, {
    isFocusing: isFocusing,
    cell: basicCell
  });

  var resetScroll = function resetScroll() {
    contentRef.current.scroll({
      top: 0
    });
  };

  var toEdit = function toEdit() {
    beforeEdit().then(function (valid) {
      if (valid) {
        setEditing(true);
      }
    });
  };

  var exitEdit = function exitEdit() {
    resetScroll();
    setEditing(false);
  };

  var onCompValueChange = function onCompValueChange(newValue) {
    if (newValue) {
      onChange(newValue, exitEdit);
    } else {
      exitEdit();
    }
  };

  (0, _ahooks.useClickAway)(function () {
    resetScroll();
  }, [contentRef, editMaskRef]);
  var editalbe = editing && !disable && mode === _constant.Mode.Editable && (0, _lodash.isFunction)(editRender);
  var cellFocusStyle = {
    zIndex: 2,
    backgroundColor: '#fff'
  };
  var contentFocusStyle = {
    zIndex: 2,
    outline: '2px solid #02B980',
    outlineOffset: '-2px',
    overflow: 'visible',
    minHeight: _constant.CellHeight.get(size),
    maxHeight: '120px',
    overflowX: 'hidden',
    overflowY: 'auto',
    height: 'auto',
    backgroundColor: '#fff'
  };
  var content;
  var safeValue = ['string', 'number'].includes(_typeof(value)) ? value.toString() : '-';

  var safeContent = /*#__PURE__*/_react.default.createElement(_ThePopover.default, {
    color: "black",
    contentType: "Text",
    content: safeValue
  }, /*#__PURE__*/_react.default.createElement(_TheEllipsis.default, {
    text: safeValue,
    config: wrapConfig
  }));

  if (editalbe) {
    content = editRender ? editRender(wrapConfig, onCompValueChange) : safeContent;
  } else {
    content = readRender ? readRender(wrapConfig) : safeContent;
  }

  var showEditIcon = mode === _constant.Mode.Editable && !disable && !editing && (0, _lodash.isFunction)(editRender);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "basic-cell",
    style: isFocusing ? cellFocusStyle : undefined,
    ref: basicCell
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "mask",
    onClick: toEdit,
    ref: editMaskRef,
    style: !showEditIcon ? {
      display: 'none'
    } : undefined
  }, editIcon ? editIcon : /*#__PURE__*/_react.default.createElement("span", {
    className: "icon icon-bianji"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "editable-cell-content-box",
    ref: contentRef,
    style: isFocusing ? contentFocusStyle : {
      overflow: 'hidden',
      height: "".concat(_constant.CellHeight.get(size))
    },
    tabIndex: 1
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "editable-cell-content",
    style: readPadding && !editalbe ? {
      padding: '6px 8px'
    } : undefined
  }, content)));
}

var MemoEditableCell = /*#__PURE__*/_react.default.memo(EditableCell, function (pre, cur) {
  var preConfig = pre.config,
      preValue = pre.value;
  var curConfig = cur.config,
      curValue = cur.value;
  var comparePropList = ['size', 'isFocusing']; // 聚焦与行高变化

  var focusingOrSizeNotChange = comparePropList.every(function (key) {
    return preConfig[key] === curConfig[key];
  }); // 值变化

  var otherPropsNotChange = preValue === curValue;
  var notChange = focusingOrSizeNotChange && otherPropsNotChange;
  return notChange;
});

function HOCEditableCell(props) {
  var _config$selectedCell, _config$selectedCell2;

  var rowIndex = props.rowIndex,
      columnIndex = props.columnIndex;
  var config = (0, _react.useContext)(_ArtTableEditableCellContext.ArtTableEditableCellContext);
  var isFocusing = rowIndex === (config === null || config === void 0 ? void 0 : (_config$selectedCell = config.selectedCell) === null || _config$selectedCell === void 0 ? void 0 : _config$selectedCell.rowIndex) && columnIndex === (config === null || config === void 0 ? void 0 : (_config$selectedCell2 = config.selectedCell) === null || _config$selectedCell2 === void 0 ? void 0 : _config$selectedCell2.columnIndex);

  var allConfig = _objectSpread(_objectSpread({}, config), {}, {
    isFocusing: isFocusing
  });

  return /*#__PURE__*/_react.default.createElement(MemoEditableCell, _objectSpread(_objectSpread({
    key: "".concat(rowIndex, "-").concat(columnIndex)
  }, props), {}, {
    config: allConfig
  }));
}

var _default = HOCEditableCell;
exports.default = _default;